/* this is a code to get the simulated DGPs of TVAR, SBVAR, SBTVARc and SBTVAR*/
/*march 2004*/
/*written by Ana Beatriz Galvao*/

new; 
output file=gendgpsp.out reset;
format /mb1 /rdc 6, 3;

tpi=timedt; print tpi; 
/*DGP*/
/*matrix with constant, coeficientes for all regimes*/
/*this is for linear*/
fimatl={0 0.5, 0.4 0, 0.5 0.8};
/* this is for non-linear*/
fimatt={0 0.5 0 0.5, 0.4 0 0.4 0, 0.8 0.8 0 0.8};
/* this is for structural break*/
fimatsb={0 0.4 0 0.6, 0.4 0 0.4 0, 0.8 0.8 0 0.8};
/*this is for sbt*/
fimatsbt={0 0.4 0 0.4 0 0.6 0 0.6, 0.4 0 0.4 0 0.4 0 0.4 0, 
         0.8 0.8 0 0.8 0.3 0.8 0 0.8};
/* thresholds*/
rsbt={2, 3};
rt={2.5};

/*break*/
bre={5000};
/*number of observations*/
nt=10000;
/*correlation*/
corr={0,-0.3,-0.6};
/*variance of y1*/;
sig={1,3};

load errs; /*drawn from normal 0,1*/

sigma=eye(2);
deco=chol(sigma);
sigmah=sigma; sigmah[1,1]=2; 
decoh=chol(sigmah);
 
yl=zeros(nt+30,2);
yt=zeros(nt+30,2);
ysb=zeros(nt+30,2);
ysbt=zeros(nt+30,2);
ysbtc=zeros(nt+30,2);
for ns (2, nt+30, 1); 
u=errs[ns,.];
uu=u*deco; /*for lower variance regime*/
uuu=u*decoh; /*for higher variance regime*/
tu=ns@-(200*floor(ns/200))@;
yl[ns,.]=(1~yl[ns-1,.])*fimatl+u;
yt[ns,.]=(((1~yt[ns-1,.])*fimatt[.,1:2]+uu).*(yt[ns-1,2].<=rt))+
       (((1~yt[ns-1,.])*fimatt[.,3:4]+uu).*(yt[ns-1,2].>rt));
ysb[ns,.]=((((1~ysb[ns-1,.])*fimatsb[.,1:2])+uu).*(tu.<=bre+30))+
         ((((1~ysb[ns-1,.])*fimatsb[.,3:4])+uu).*(tu.>bre+30));
ysbt[ns,.]=((((1~ysbt[ns-1,.])*fimatsbt[.,1:2]+uu).*(ysbt[ns-1,2].<=rsbt[1]))+
          (((1~ysbt[ns-1,.])*fimatsbt[.,3:4]+uu).*(ysbt[ns-1,2].>rsbt[1]))).*(tu.<=bre+30)+
          ((((1~ysbt[ns-1,.])*fimatsbt[.,5:6]+uu).*(ysbt[ns-1,2].<=rsbt[2]))+
          (((1~ysbt[ns-1,.])*fimatsbt[.,7:8]+uu).*(ysbt[ns-1,2].>rsbt[2]))).*(tu.>bre+30);
ysbtc[ns,.]=((((1~ysbtc[ns-1,.])*fimatsbt[.,1:2]+uu).*(ysbtc[ns-1,2].<=rt))+
          (((1~ysbtc[ns-1,.])*fimatsbt[.,3:4]+uu).*(ysbtc[ns-1,2].>rt))).*(tu.<=bre+30)+
          ((((1~ysbtc[ns-1,.])*fimatsbt[.,5:6]+uu).*(ysbtc[ns-1,2].<=rt))+
          (((1~ysbtc[ns-1,.])*fimatsbt[.,7:8]+uu).*(ysbtc[ns-1,2].>rt))).*(tu.>bre+30);
endfor;
yl=yl[31:rows(yl),.]; 
yt=yt[31:rows(yt),.];
ysb=ysb[31:rows(ysb),.];
ysbt=ysbt[31:rows(ysbt),.];
ysbtc=ysbtc[31:rows(ysbtc),.];

"linear, threshold and break";
print yl[2:rows(yt),1]~yl[1:rows(yt)-1,2]~yt[2:rows(yt),1]~yt[1:rows(yt)-1,2]~ysb[2:rows(ysb),1]~ysb[1:rows(yt)-1,2];
"SBTVARc and SBTVAR";
print ysbtc[2:rows(yt),1]~ysbtc[1:rows(yt)-1,2]~ysbt[2:rows(yt),1]~ysbt[1:rows(yt)-1,2];

end; 
