/* this is a code to find out which is the best estimator for TVAR, SBVAR,
SBTVARc, SBTVAR */
/* written by Ana Beatriz Galvo*/
/*March 2004*/

new; 
output file=mcestim.out reset;
format /mb1 /rdc 6, 3;
tpi=timedt; print tpi; 
/* monte carlo replications*/
rep=500;
/*DGP*/
/*this is for linear*/
fimatl={0 0.5, 0.4 0, 0.5 0.8};
/* this is for non-linear*/
fimatt={0 0.5 0 0.5, 0.4 0 0.4 0, 0.8 0.8 0 0.8};
/* this is for structural break*/
fimatsb={0 0.4 0 0.6, 0.4 0 0.4 0, 0.8 0.8 0 0.8};
/*this is for sbt*/
fimatsbt={0 0.4 0 0.4 0 0.6 0 0.6, 0.4 0 0.4 0 0.4 0 0.4 0, 
         0.8 0.8 0 0.8 0.3 0.8 0 0.8};
/* thresholds*/
rsbt={2, 3};
rt={2.5};
/*globals for estimation*/
pr2=.30;
prt=.20;
pr=.15;
/*break*/
bre={100,200};
/*number of observations*/
n={200/*,400*/};
/*correlation*/
corr={0,-0.3,-0.6};
/*variance of y1*/;
sig={1,3};
/*to save results*//*order: method, par, att*/
tabtvar=zeros(3*1*3,rows(corr)*rows(sig)*rows(n));
tabsbvar=zeros(3*1*3,rows(corr)*rows(sig)*rows(n));
tabsbtvarc=zeros(3*2*3,rows(corr)*rows(sig)*rows(n));
tabsbtvar=zeros(3*3*3,rows(corr)*rows(sig)*rows(n));
/*getting random numbers*/
load err1;
load err2;

for ni (1, rows(n), 1);
nt=n[ni];
brei=bre[ni];
for nc (1, rows(corr), 1); 
corri=corr[nc];
sigma=eye(2);
sigma[1,2]=corri;
sigma[2,1]=corri; 
deco=chol(sigma);
for nsi (1, rows(sig), 1);
covi=corri*sqrt(sig[nsi]);
sigmah=eye(2); sigmah[1,1]=sig[nsi]; sigmah[1,2]=covi; sigmah[2,1]=covi; 
decoh=chol(sigmah);

tvari=zeros(rep,3*1);
sbvari=zeros(rep,3*1);
sbtvarci=zeros(rep,3*2);
sbtvari=zeros(rep,3*3);

for nr (1, rep, 1);
/*getting simulated data*/ 
yt=zeros(nt+30,2);
ysb=zeros(nt+30,2);
ysbt=zeros(nt+30,2);
ysbtc=zeros(nt+30,2);
for ns (2, nt+30, 1); 
u=err1[ns,nr]~err2[ns,nr];
uu=(deco*u')'; /*for lower variance regime*/
uuu=(decoh*u')'; /*for higher variance regime*/
tu=ns;
yt[ns,.]=(((1~yt[ns-1,.])*fimatt[.,1:2]+uuu).*(yt[ns-1,2].<=rt))+
       (((1~yt[ns-1,.])*fimatt[.,3:4]+uu).*(yt[ns-1,2].>rt));
ysb[ns,.]=((((1~ysb[ns-1,.])*fimatsb[.,1:2])+uuu).*(tu.<=brei+30))+
         ((((1~ysb[ns-1,.])*fimatsb[.,3:4])+uu).*(tu.>brei+30));

ysbt[ns,.]=((((1~ysbt[ns-1,.])*fimatsbt[.,1:2]+uuu).*(ysbt[ns-1,2].<=rsbt[1]))+
          (((1~ysbt[ns-1,.])*fimatsbt[.,3:4]+uuu).*(ysbt[ns-1,2].>rsbt[1]))).*(tu.<=brei+30)+
          ((((1~ysbt[ns-1,.])*fimatsbt[.,5:6]+uu).*(ysbt[ns-1,2].<=rsbt[2]))+
          (((1~ysbt[ns-1,.])*fimatsbt[.,7:8]+uu).*(ysbt[ns-1,2].>rsbt[2]))).*(tu.>brei+30);
ysbtc[ns,.]=((((1~ysbtc[ns-1,.])*fimatsbt[.,1:2]+uuu).*(ysbtc[ns-1,2].<=rt))+
          (((1~ysbtc[ns-1,.])*fimatsbt[.,3:4]+uuu).*(ysbtc[ns-1,2].>rt))).*(tu.<=brei+30)+
          ((((1~ysbtc[ns-1,.])*fimatsbt[.,5:6]+uu).*(ysbtc[ns-1,2].<=rt))+
          (((1~ysbtc[ns-1,.])*fimatsbt[.,7:8]+uu).*(ysbtc[ns-1,2].>rt))).*(tu.>brei+30);
endfor; 
yt=yt[31:rows(yt),.];
ysb=ysb[31:rows(ysb),.];
ysbt=ysbt[31:rows(ysbt),.];
ysbtc=ysbtc[31:rows(ysbtc),.];
/*using the first dgp*/
yet=trimr(yt,1,0);
xet=ones(nt-1,1)~yt[1:nt-1,.];
qet=yt[1:nt-1,2];
{estet}=tvarest(yet,xet,qet);/*estet is a 4X1 matrix with line for method and columm for parameter*/
tvari[nr,.]=(estet)';
/*print tvari[nr,.];*/
/*using second dgp*/
yesb=trimr(ysb,1,0);
xesb=ones(nt-1,1)~ysb[1:nt-1,.];
{estsb}=sbvarest(yesb,xesb);
sbvari[nr,.]=(estsb)';
/*print sbvari[nr,.];*/
/*using third sgp*/
yesbtc=trimr(ysbtc,1,0);
xesbtc=ones(nt-1,1)~ysbtc[1:nt-1,.];
qesbtc=ysbtc[1:nt-1,2];
{estsbtc}=jointest(yesbtc,xesbtc,qesbtc);
sbtvarci[nr,.]=vecr(estsbtc)';
/*print sbtvarci[nr,.];*/
/*using fourfh dgp*/
yesbt=trimr(ysbt,1,0);
xesbt=ones(nt-1,1)~ysbt[1:nt-1,.];
qesbt=ysbt[1:nt-1,2];
{estsbt}=sbtvarest(yesbt,xesbt,qesbt);
sbtvari[nr,.]=vecr(estsbt)';
/*print sbtvari[nr,.];*/
endfor; 
/*now saving the results*/ /*organised by method of estimation*/
print nsi+2*(nc-1)+6*(ni-1);

tabtvar[1:3,nsi+2*(nc-1)+6*(ni-1)]=meanc(tvari[.,1])|stdc(tvari[.,1])|(meanc(tvari[.,1]-rt));
tabtvar[4:6,nsi+2*(nc-1)+6*(ni-1)]=meanc(tvari[.,2])|stdc(tvari[.,2])|(meanc(tvari[.,2]-rt));
tabtvar[7:9,nsi+2*(nc-1)+6*(ni-1)]=meanc(tvari[.,3])|stdc(tvari[.,3])|(meanc(tvari[.,3]-rt));

tabsbvar[1:3,nsi+2*(nc-1)+6*(ni-1)]=meanc(sbvari[.,1])|stdc(sbvari[.,1])|(meanc(sbvari[.,1]-brei));
tabsbvar[4:6,nsi+2*(nc-1)+6*(ni-1)]=meanc(sbvari[.,2])|stdc(sbvari[.,2])|(meanc(sbvari[.,2]-brei));
tabsbvar[7:9,nsi+2*(nc-1)+6*(ni-1)]=meanc(sbvari[.,3])|stdc(sbvari[.,3])|(meanc(sbvari[.,3]-brei));

tabsbtvarc[1:6,nsi+2*(nc-1)+6*(ni-1)]=meanc(sbtvarci[.,1])|stdc(sbtvarci[.,1])|(meanc(sbtvarci[.,1]-rt))|
                                       meanc(sbtvarci[.,2])|stdc(sbtvarci[.,2])|(meanc(sbtvarci[.,2]-brei));
tabsbtvarc[7:12,nsi+2*(nc-1)+6*(ni-1)]=meanc(sbtvarci[.,3])|stdc(sbtvarci[.,3])|(meanc(sbtvarci[.,3]-rt))|
                                       meanc(sbtvarci[.,4])|stdc(sbtvarci[.,4])|(meanc(sbtvarci[.,4]-brei));
tabsbtvarc[13:18,nsi+2*(nc-1)+6*(ni-1)]=meanc(sbtvarci[.,5])|stdc(sbtvarci[.,5])|(meanc(sbtvarci[.,5]-rt))|
                                       meanc(sbtvarci[.,6])|stdc(sbtvarci[.,6])|(meanc(sbtvarci[.,6]-brei));

tabsbtvar[1:9,nsi+2*(nc-1)+6*(ni-1)]=meanc(sbtvari[.,1])|stdc(sbtvari[.,1])|(meanc(sbtvari[.,1]-rsbt[1]))|
                                      meanc(sbtvari[.,2])|stdc(sbtvari[.,2])|(meanc(sbtvari[.,2]-rsbt[2]))| 
                                      meanc(sbtvari[.,3])|stdc(sbtvari[.,3])|(meanc(sbtvari[.,3]-brei));
tabsbtvar[10:18,nsi+2*(nc-1)+6*(ni-1)]=meanc(sbtvari[.,4])|stdc(sbtvari[.,4])|(meanc(sbtvari[.,4]-rsbt[1]))|
                                      meanc(sbtvari[.,5])|stdc(sbtvari[.,5])|(meanc(sbtvari[.,5]-rsbt[2]))| 
                                      meanc(sbtvari[.,6])|stdc(sbtvari[.,6])|(meanc(sbtvari[.,6]-brei));
tabsbtvar[19:27,nsi+2*(nc-1)+6*(ni-1)]=meanc(sbtvari[.,7])|stdc(sbtvari[.,7])|(meanc(sbtvari[.,7]-rsbt[1]))|
                                      meanc(sbtvari[.,8])|stdc(sbtvari[.,8])|(meanc(sbtvari[.,8]-rsbt[2]))| 
                                      meanc(sbtvari[.,9])|stdc(sbtvari[.,9])|(meanc(sbtvari[.,9]-brei));
endfor; 
endfor; 
endfor; 
"table for estimation of TVAR";
print tabtvar;
"table for estimation of SBVAR";
print tabsbvar;
"table for estimation of sbtvarc";
print tabsbtvarc;
"table for estimation of sbtvar";
print tabsbtvar;
tpi=timedt; print tpi;
end; 

/*******************************************************************/
proc(1)=tvarest(y, x, q); 
local t,qi, qq1, qq2, step, qq, qqn, sq, qqd, du, xl, xh, yl, yh, el, eh,
sil, sih, ghat, xg, eg, ieg, elg, sige, elin,xx ;   

t=rows(y); 
qi=sortc(q[.,1],1);
qq1=qi[floor(t*pr)];
qq2=qi[floor(t*(1-pr))];
step=((qq2-qq1)/100);
qq=seqa(qq1, step, 100);
qqn=rows(qq);
sq=zeros(qqn, 3);
xx=invpd(x'x);
elin=y-x*xx*(x'y);
 
for i(1, qqn, 1);
qqd=qq[i];
du=(q.<=qqd);  
xg=x.*du;
eg=xg-(x*xx*(x'xg));
ieg=invpd(eg'eg); 
elg=elin-(eg*ieg*(eg'elin));
sige=(elg'elg)./rows(elg);   
sq[i,1]=sumc(diag(sige));
sq[i,2]=ln(det(sige));
xl=selif(x, du); xh=selif(x, (1-du));
yl=selif(y, du); yh=selif(y, (1-du));
el=yl-xl*invpd(xl'xl)*(xl'yl); 
eh=yh-xh*invpd(xh'xh)*(xh'yh);
sil=(el'el)./rows(el); sih=(eh'eh)./rows(eh); 
sq[i,3]=rows(el)*ln(det(sil))+rows(eh)*ln(det(sih));
endfor; 
ghat=qq[minindc(sq[.,1])]|qq[minindc(sq[.,2])]|qq[minindc(sq[.,3])];
retp(ghat);
endp; 


proc(1)=sbvarest(y, x);
local t,tim, qq1, qq2, step, qq, qqn, s, qqd, du, xl, xh, yl, yh, el, eh,
sil, sih, that, xg, eg, ieg, elg, sige, xx, elin;   

t=rows(y); 
tim=seqa(1, 1, t);
qq1=tim[floor(t*pr)];
qq2=tim[floor(t*(1-pr))];
step=((qq2-qq1)/100);
qq=seqa(qq1, step, 100);
qqn=rows(qq);
s=zeros(qqn, 3);
xx=invpd(x'x);
elin=y-x*xx*(x'y);
 
for i(1, qqn, 1);
qqd=qq[i];
du=(tim.<=qqd);  
xg=x.*du;
eg=xg-(x*xx*(x'xg));
ieg=invpd(eg'eg); 
elg=elin-(eg*ieg*(eg'elin));
sige=(elg'elg)./rows(elg);  
s[i,1]=sumc(diag(sige));
s[i,2]=ln(det(sige));
xl=selif(x, du); xh=selif(x, (1-du));
yl=selif(y, du); yh=selif(y, (1-du));
el=yl-xl*invpd(xl'xl)*(xl'yl); 
eh=yh-xh*invpd(xh'xh)*(xh'yh);
sil=(el'el)/rows(el); sih=(eh'eh)/rows(eh);
s[i,3]=rows(el)*ln(det(sil))+rows(eh)*ln(det(sih)); 
endfor; 
that=qq[minindc(s[.,1])]|qq[minindc(s[.,2])]|qq[minindc(s[.,3])];

retp(that);
endp; 

proc(1)=jointest(y, x, q);
local  tim, t, r1, r2, step, r, rr, st, gat, tp, qt1, qt2, qt, s,qq1, qq2,
qd, qqd, q1x, q1n, q2x, q2n,qq, xi1, yi1, xi2, yi2,du1, xi1l,yi1l,
xi1h,yi1h,xi2l,yi2l,xi2h,yi2h,ui1l,ui1h,ui2l,ui2h,du2,sig1l, sig2l,dg,
sig1h, sig2h, ghat, taf, qi1, qi2, nq, xx, elin,xg, eg, ieg, elg, sige,dt ;   

t=rows(y); 
tim=seqa(1, 1, t);
r1=ceil(pr2*t); 
r2=floor((1-pr2)*t);
step=(r2-r1)/round(.3*rows(y));
r=seqa(r1, step, round(.3*rows(y)));
rr=rows(r);
st=zeros(rr,3); 
gat=zeros(rr,3);
xx=invpd(x'x);
elin=y-x*xx*(x'y);

for i(1,rr, 1);
dt=(tim.<=r[i]); 
xi1=x[1:r[i],.]; yi1=y[1:r[i],.]; qi1=q[1:r[i],.]; 
xi2=x[r[i]+1:t,.]; yi2=y[r[i]+1:t,.]; qi2=q[r[i]+1:t,.]; 
qt1=sortc(qi1[.,1],1);
qt1=qt1[(floor(prt*rows(qt1)))+1:ceil((1-prt)*rows(qt1))];
qt2=sortc(qi2[.,1],1);
qt2=qt2[(floor(prt*rows(qt2)))+1:ceil((1-prt)*rows(qt2))];
q1x=maxc(qt1); q1n=minc(qt1);
q2x=maxc(qt2); q2n=minc(qt2);
qq1=minc(q1x|q2x); qq2=maxc(q1n|q2n);
qt=seqa(qq2, (qq1-qq2)/100, 100);
nq=rows(qt); 
s=zeros(nq,3);
for hh (1, nq, 1); 
qqd=qt[hh];
dg=(q.<=qqd); 
xg=(x.*dt)~(x.*dg)~(x.*(dt.*dg));
eg=xg-(x*xx*(x'xg));
ieg=ginv(eg'eg); 
elg=elin-(eg*ieg*(eg'elin));
sige=(elg'elg)./rows(elg); 
s[hh,1]=sumc(diag(sige));
s[hh,2]=ln(det(sige));
du1=(qi1.<=qqd);
xi1l=selif(xi1,du1); yi1l=selif(yi1,du1); 
xi1h=delif(xi1,du1); yi1h=delif(yi1,du1);
ui1l=yi1l-xi1l*(invpd(xi1l'xi1l)*(xi1l'yi1l));
ui1h=yi1h-xi1h*(invpd(xi1h'xi1h)*(xi1h'yi1h)); 
sig1l=(ui1l'ui1l)./rows(ui1l); sig1h=(ui1h'ui1h)./rows(ui1h);
du2=(qi2.<=qqd);
xi2l=selif(xi2,du2); yi2l=selif(yi2,du2); 
xi2h=delif(xi2,du2); yi2h=delif(yi2,du2);
ui2l=yi2l-xi2l*(invpd(xi2l'xi2l)*(xi2l'yi2l));
ui2h=yi2h-xi2h*(invpd(xi2h'xi2h)*(xi2h'yi2h)); 
sig2l=(ui2l'ui2l)./rows(ui2l); sig2h=(ui2h'ui2h)./rows(ui2h);
s[hh,3]=rows(ui1l)*ln(det(sig1l))+rows(ui1h)*ln(det(sig1h))
      +rows(ui2l)*ln(det(sig2l))+rows(ui2h)*ln(det(sig2h)); 
endfor; 
st[i,.]=minc(s)';
gat[i,.]=qt[minindc(s[.,1])]~qt[minindc(s[.,2])]~qt[minindc(s[.,3])];
endfor;
taf=(r[minindc(st[.,1])])|(r[minindc(st[.,2])])|(r[minindc(st[.,3])]); 
ghat=gat[minindc(st[.,1]),1]|gat[minindc(st[.,2]),2]|gat[minindc(st[.,3]),3];

retp(ghat~taf); 
endp; 

proc(1) = sbtvarest (y, x, q); 
local t, r1, r2, step, r, rr, ss, resu, xi1, yi1, qi1,qq1, qqr1, qqn1, ss1;
local qqd, du, xi1l, yi1l, xi1h, yi1h, xi2l, yi2l, xi2h, yi2h,xi2, yi2,
qi2,qq2, qqr2, qqn2, ss2, ui1l, ui2l, ui1h, ui2h, ti1, ti2, xg, eg, ieg, elg, dg, sige;   
local sigl, sigh, st, taf, ghat1, ghat2, xx1, elin1, xx2, elin2, s1, g1, g2, s2; 

t=rows(y); 
r1=ceil(pr2*t); 
r2=floor((1-pr2)*t);
step=(r2-r1)/round(.3*rows(y));
r=seqa(r1,step, round(.3*rows(y)));
rr=rows(r);
s1=zeros(rr,3); 
g1=zeros(rr,3);
s2=zeros(rr,3); 
g2=zeros(rr,3);


/*search over time */ 
for i (1, rr, 1);
/*the lower part */
xi1=x[1:r[i],.]; yi1=y[1:r[i],.]; qi1=q[1:r[i],.]; 
ti1=rows(xi1); 
/*the threshold estimation */
qq1=sortc(qi1[.,1],1);
qqr1=trimr(qq1, ceil(prt*ti1), ceil (prt*ti1));
qqn1=rows(qqr1);
ss1=zeros(qqn1, 3);
xx1=invpd(xi1'xi1);
elin1=yi1-xi1*xx1*(xi1'yi1); 
for j (1, qqn1,1);   
qqd=qqr1[j];
du=(qi1.<=qqd);
xg=xi1.*du;
eg=xg-(xi1*xx1*(xi1'xg));
ieg=invpd(eg'eg); 
elg=elin1-(eg*ieg*(eg'elin1));
sige=(elg'elg)./rows(elg);  
ss1[j,1]=sumc(diag(sige));
ss1[j,2]=ln(det(sige));
xi1l=selif(xi1,du); yi1l=selif(yi1,du); 
xi1h=delif(xi1,du); yi1h=delif(yi1,du);
ui1l=yi1l-xi1l*(invpd(xi1l'xi1l)*(xi1l'yi1l));
ui1h=yi1h-xi1h*(invpd(xi1h'xi1h)*(xi1h'yi1h)); 
sigl=(ui1l'ui1l)./rows(ui1l); sigh=(ui1h'ui1h)./rows(ui1h);
ss1[j,3]=rows(ui1l)*ln(det(sigl))+rows(ui1h)*ln(det(sigh));
endfor; 
s1[i,.]=minc(ss1)';
g1[i,.]=qqr1[minindc(ss1[.,1])]~qqr1[minindc(ss1[.,2])]~qqr1[minindc(ss1[.,3])]; 
/*the upper part */
xi2=x[r[i]+1:t,.]; yi2=y[r[i]+1:t,.]; qi2=q[r[i]+1:t,.]; 
ti2=rows(xi2); 
/*the threshold estimation */
qq2=sortc(qi2[.,1],1);
qqr2=trimr(qq2, ceil(prt*ti2), ceil (prt*ti2));
qqn2=rows(qqr2);
ss2=zeros(qqn2,3);
xx2=invpd(xi2'xi2);
elin2=yi2-xi2*xx2*(xi2'yi2); 
for o (1, qqn2, 1);
qqd=qqr2[o];
du=(qi2.<=qqd);  
xg=xi2.*du;
eg=xg-(xi2*xx2*(xi2'xg));
ieg=invpd(eg'eg); 
elg=elin2-(eg*ieg*(eg'elin2));
sige=(elg'elg)./rows(elg);  
ss2[o,1]=sumc(diag(sige));
ss2[o,2]=ln(det(sige));
xi2l=selif(xi2,du); yi2l=selif(yi2,du); 
xi2h=delif(xi2,du); yi2h=delif(yi2,du);
ui2l=yi2l-xi2l*(invpd(xi2l'xi2l)*(xi2l'yi2l));
ui2h=yi2h-xi2h*(invpd(xi2h'xi2h)*(xi2h'yi2h)); 
sigl=(ui2l'ui2l)./rows(ui2l); sigh=(ui2h'ui2h)./rows(ui2h);
ss2[o,3]=rows(ui2l)*ln(det(sigl))+rows(ui2h)*ln(det(sigh));
endfor; 
s2[i,.]=minc(ss2)';
g2[i,.]=qqr2[minindc(ss2[.,1])]~qqr2[minindc(ss2[.,2])]~qqr2[minindc(ss2[.,3])]; 
endfor; 

st= s1+s2;
taf=(r[minindc(st[.,1])])|(r[minindc(st[.,2])])|(r[minindc(st[.,3])]);
ghat1=g1[minindc(st[.,1]),1]|g1[minindc(st[.,2]),2]|g1[minindc(st[.,3]),3];
ghat2=g2[minindc(st[.,1]),1]|g2[minindc(st[.,2]),2]|g2[minindc(st[.,3]),3];

retp(ghat1~ghat2~taf); 
endp;


proc ginv(m);
local mi;
trap 1;
mi=invpd(m);
if scalerr(mi);
mi=pinv(m);
endif;
if scalerr(mi);
trap 0;
mi=invswp(m);
endif;
retp(mi);
endp;
