/* this code does in-sample analysis of VAR, TVAR, SBVAR, SBTVARc and SBTVAR
with US data*/
/*written by Ana Beatriz Galvao*/
/*January 2004*/
new; 

/*number of endogenous variables*/ l=2;
/*autoregressive order */ phat=3;
/*maximum delay order*/ dmax=4;
/*triming for threshold*/pr=.15;
/*triming for the structural break */pr2=.30;
/* triming for sbt model*/prt=.20;
/*begining of forecasting*/t0=130;
/* grid for sbt*/ gr=.4*(.3*200);
/*replications to build confidence interval*/ rep=5; 


load y[199,2]=data03.csv; /* this is the new vintage data, nov 03*/
output file=newestte.out reset;
format /mb1 /rdc 8, 4;
nn=rows(y); /*maximum number of observations*/
print "nunber of observations" nn-dmax;
print "number of replications for 90% confidence intervals" rep; 
/*organising data*/
yi=y[1:nn,.];
q=yi[.,2];
qq=zeros(nn-dmax, 1); 
i=1; do while i<=dmax; 
qq=qq~q[1+dmax-i:nn-i];
i=i+1; endo; 
qe=qq[.,2:dmax+1];
ye=trimr(yi, dmax, 0); 
xe=xmatrix(yi,phat);
nn=rows(ye);

/*VAR*/
b_var=invpd(xe'xe)*(xe'ye);
e_var=ye-(xe*b_var);
sigvar=(e_var'e_var)./rows(e_var);
"var information criteria" nn*(ln(det(sigvar)))~(l*(phat*l+1));
"unique regime with" rows(e_var);
"variances" sigvar[1,1]|sigvar[2,2];
/* TVAR*/
{dhat, rhat, shat}=threest(ye, xe, qe);
{bl2, bh2, el2, eh2}=twotest(ye, xe, qe, dhat, rhat);
sigl2=(el2'el2)./rows(el2); sigh2=(eh2'eh2)./rows(eh2);
"2rtvar information criteria" (rows(el2)*ln(det(sigl2))+rows(eh2)*ln(det(sigh2)))~((2*l*(phat*l+1))+2);
"delay and threshold" dhat~rhat;
"regimes with" rows(el2)~rows(eh2);
"variances" (sigl2[1,1]|sigl2[2,2])~(sigh2[1,1]|sigh2[2,2]);
y0=yi[1:dmax,.];
{c2}=twotestdp(y0,dhat, rhat, bl2, bh2, el2, eh2);
"confidence interval for threshold" c2;
/*3R-TVAR*/
{dhatn, rhatn, rhat1, rhat2, shatn, shat2}=threest3(ye, xe, qe);
"thresholds for model with three regimes" rhat1~rhat2;  
/*SBVAR*/
{that}=sbm(ye,xe);
{bbt, bat, ebt, eat} =sbmest(ye,xe,that);
siga=(eat'eat)./(rows(eat)); sigb=(ebt'ebt)./rows(ebt);
print "sbm information criteria" (rows(eat)*ln(det(siga))+rows(ebt)*ln(det(sigb)))~((2*l*(phat*l+1))+1);
print "break-point" ((that+dmax)/4)+(1953+0.25);
"regimes with" rows(ebt)~rows(eat);
"variances" (sigb[1,1]|sigb[2,2])~(siga[1,1]|siga[2,2]);
{ct}=sbmdp(y0, that, bbt, bat, ebt, eat);
"confidence interval for structural break" ((ct[1,1]+dmax)/4)+(1953+0.25)~((ct[1,2]+dmax)/4)+(1953+0.25); 
/*2-SBVAR*/
{that1,that2}=sbm2(ye,xe);
print "break-points for model with two breaks" ((that1+dmax)/4)+(1953+0.25)~((that2+dmax)/4)+(1953+0.25);

/*SBTVARc*/
{thatc,dhatc,ghatc}=sbtvarc(ye, xe, qe);
ysb=selif(ye, seqa(1,1,rows(ye)).>thatc);
xsb=selif(xe, seqa(1,1,rows(ye)).>thatc);
qsb=selif(qe, seqa(1,1,rows(ye)).>thatc);
{bla10, bha10, ela10, eha10}=twotest(ysb, xsb, qsb, dhatc, ghatc);
ysb=delif(ye, seqa(1,1,rows(ye)).>thatc);
xsb=delif(xe, seqa(1,1,rows(ye)).>thatc);
qsb=delif(qe, seqa(1,1,rows(ye)).>thatc);
{blb10, bhb10, elb10, ehb10}=twotest(ysb, xsb, qsb, dhatc, ghatc);
sigla=(ela10'ela10)./rows(ela10); sigha=(eha10'eha10)./rows(eha10);
siglb=(elb10'elb10)./rows(elb10); sighb=(ehb10'ehb10)./rows(ehb10);
"information citeria for SBTVARc"
(rows(ela10)*ln(det(sigla))+rows(eha10)*ln(det(sigha))+rows(elb10)*ln(det(siglb))+rows(ehb10)*ln(det(sighb)))~(4*l*(l*phat+1))+3;
print "break-point" ((thatc+dmax)/4)+(1953+0.25);
print "delay and threshold" dhatc~ghatc;
"regimes with" rows(elb10)~rows(ehb10)~rows(ela10)~rows(eha10);
"variances" (siglb[1,1]|siglb[2,2])~(sighb[1,1]|sighb[2,2])~(sigla[1,1]|sigla[2,2])~(sigha[1,1]|sigha[2,2]);
{cc}=jointdp(y0,thatc,dhatc,ghatc,blb10,bhb10,bla10,bha10,elb10,ehb10,ela10,eha10);
"confidence interval for structural break" ((cc[1,1]+dmax)/4)+(1953+0.25)~((cc[1,2]+dmax)/4)+(1953+0.25); 
" confidence interval for threshold" cc[2,.];


/*SBTVAR*/
{thatt, ghat1, ghat2, dhat1, dhat2}=tvtvar (ye, xe, qe);
ysb=selif(ye, seqa(1,1,rows(ye)).>thatt);
xsb=selif(xe, seqa(1,1,rows(ye)).>thatt);
qsb=selif(qe, seqa(1,1,rows(ye)).>thatt);
{bla12, bha12, ela12, eha12}=twotest(ysb, xsb, qsb, dhat2, ghat2);
ysb=delif(ye, seqa(1,1,rows(ye)).>thatt);
xsb=delif(xe, seqa(1,1,rows(ye)).>thatt);
qsb=delif(qe, seqa(1,1,rows(ye)).>thatt);
{blb12, bhb12, elb12, ehb12}=twotest(ysb, xsb, qsb, dhat1, ghat1);
sigla=(ela12'ela12)./rows(ela12); sigha=(eha12'eha12)./rows(eha12);
siglb=(elb12'elb12)./rows(elb12); sighb=(ehb12'ehb12)./rows(ehb12);
"information citeria for SBTVAR" 
(rows(ela12)*ln(det(sigla))+rows(eha12)*ln(det(sigha))+rows(elb12)*ln(det(siglb))+rows(ehb12)*ln(det(sighb)))~(4*l*(l*phat+1))+3;
print "break-point" ((thatt+dmax)/4)+(1953+0.25);
print "delay and threshold of first sample" dhat1~ghat1;
print "delay and threshold of second sample" dhat2~ghat2;
"regimes with" rows(elb12)~rows(ehb12)~rows(ela12)~rows(eha12);
"variances" (siglb[1,1]|siglb[2,2])~(sighb[1,1]|sighb[2,2])~(sigla[1,1]|sigla[2,2])~(sigha[1,1]|sigha[2,2]);
{cbt}=tvtvardp(y0,thatt,dhat1,dhat2,ghat1,ghat2,blb12,bhb12,bla12,bha12,elb12,ehb12,ela12,eha12);
"confidence interval for structural break" ((cbt[1,1]+dmax)/4)+(1953+0.25)~((cbt[1,2]+dmax)/4)+(1953+0.25); 
" confidence interval for first threshold" cbt[2,.];
" confidence interval for second threshold" cbt[3,.];

cor=1/(2*ln(ln(rows(ye)))); n=rows(ye); tim=seqa(1,1,n); 
"confidence bounds of VAR X TVAR"; 
xt=(xe.*(qe[.,dhat].<=rhat))~(xe.*(qe[.,dhat].>rhat));
et=ye-xt*(invpd(xt'xt)*(xt'ye));
w1=sqrt(n*((sumc(diag(e_var'e_var))-sumc(diag(et'et)))/sumc(diag(et'et))));
w1=cor*w1;
lm1=sqrt(n*((sumc(diag(e_var'e_var))-sumc(diag(et'et)))/sumc(diag(e_var'e_var))));
lm1=cor*lm1;
print w1~lm1;
"confidence bounds of VAR X SBVAR";
xb=(xe.*(tim.<=that))~(xe.*(tim.>that));
eb=ye-xb*(invpd(xb'xb)*(xb'ye));
w2=sqrt(n*((sumc(diag(e_var'e_var))-sumc(diag(eb'eb)))/sumc(diag(eb'eb))));
w2=cor*w2;
lm2=sqrt(n*((sumc(diag(e_var'e_var))-sumc(diag(eb'eb)))/sumc(diag(e_var'e_var))));
lm2=cor*lm2;
print w2~lm2; 
"confidence bounds of TVAR X SbTVARc";
xbtc=(((xe.*(qe[.,dhatc].<=ghatc))~(xe.*(qe[.,dhatc].>ghatc))).*(tim.<=thatc))~
     (((xe.*(qe[.,dhatc].<=ghatc))~(xe.*(qe[.,dhatc].>ghatc))).*(tim.>thatc));
ebtc=ye-xbtc*(invpd(xbtc'xbtc)*(xbtc'ye));
w3=sqrt(n*((sumc(diag(et'et))-sumc(diag(ebtc'ebtc)))/sumc(diag(ebtc'ebtc))));
w3=cor*w3;
lm3=sqrt(n*((sumc(diag(et'et))-sumc(diag(ebtc'ebtc)))/sumc(diag(et'et))));
lm3=cor*lm3;
print w3~lm3; 
"confidence bounds of TVAR X SBTVAR";
xbt=(((xe.*(qe[.,dhat1].<=ghat1))~(xe.*(qe[.,dhat1].>ghat1))).*(tim.<=thatt))~
     (((xe.*(qe[.,dhat2].<=ghat2))~(xe.*(qe[.,dhat2].>ghat2))).*(tim.>thatt));
ebt=ye-xbt*(invpd(xbt'xbt)*(xbt'ye));
w4=sqrt(n*((sumc(diag(et'et))-sumc(diag(ebt'ebt)))/sumc(diag(ebt'ebt))));
w4=cor*w4;
lm4=sqrt(n*((sumc(diag(et'et))-sumc(diag(ebt'ebt)))/sumc(diag(et'et))));
lm4=cor*lm4;
print w4~lm4; 
"confidence bounds of SBVAR X SBTVARc";
w5=sqrt(n*((sumc(diag(eb'eb))-sumc(diag(ebtc'ebtc)))/sumc(diag(ebtc'ebtc))));
w5=cor*w5;
lm5=sqrt(n*((sumc(diag(eb'eb))-sumc(diag(ebtc'ebtc)))/sumc(diag(eb'eb))));
lm5=cor*lm5;
print w5~lm5;
"confidence bounds of SBVAR X SBTVAR";
w6=sqrt(n*((sumc(diag(eb'eb))-sumc(diag(ebt'ebt)))/sumc(diag(ebt'ebt))));
w6=cor*w6;
lm6=sqrt(n*((sumc(diag(eb'eb))-sumc(diag(ebt'ebt)))/sumc(diag(eb'eb))));
lm6=cor*lm6;
print w6~lm6;
"confidence bounds of TVAR X TVAR2";
xt3=(xe.*(qe[.,dhatn].<=rhat1))~
   (xe.*((qe[.,dhatn].>rhat1).*(qe[.,dhatn].<=rhat2)))~
    (xe.*(qe[.,dhatn].>rhat2));
et3=ye-xt3*(invpd(xt3'xt3)*(xt3'ye));
w7=sqrt(n*((sumc(diag(et'et))-sumc(diag(et3'et3)))/sumc(diag(et3'et3))));
w7=cor*w7;
lm7=sqrt(n*((sumc(diag(et'et))-sumc(diag(et3'et3)))/sumc(diag(et'et))));
lm7=cor*lm7;
print w7~lm7;
"confidence bounds of SBVAR X SBVAR2";
xb2=(xe.*(tim.<=that1))~
   (xe.*((tim.>that1).*(tim.<=that2)))~
    (xe.*(tim.>that2));
eb2=ye-xb2*(invpd(xb2'xb2)*(xb2'ye));
w8=sqrt(n*((sumc(diag(eb'eb))-sumc(diag(eb2'eb2)))/sumc(diag(eb2'eb2))));
w8=cor*w8;
lm8=sqrt(n*((sumc(diag(eb'eb))-sumc(diag(eb2'eb2)))/sumc(diag(eb'eb))));
lm8=cor*lm8;
print w8~lm8; 

end; 


proc(1)=xmatrix(y, p); 
local x, xx, i, j, t; 
t=rows(y)-dmax; 
x=ones(t, 1);
i=1; do while i<=cols(y); 
xx=y[.,i];
j=1; do while j<=p; 
x=x~xx[1+dmax-j:t+dmax-j];
j=j+1; endo;i=i+1;endo;
retp(x); 
endp; 

proc(3)=threest (y, x, q);
local t,k, qi, n1, qq, qqs, qqn, s, qqd, du, xl, xh, yl, yh, el, eh, sil, sih; 
local ghat, d, dhat, shat, qd; 

d=cols(q); 
t=rows(y); 
k=cols(x);
qi=sortc(q[.,1],1);
qq=qi[floor(pr*t)+1:ceil((1-pr)*t)];
qqn=rows(qq);
s=zeros(qqn,d);
 
for j (1, d, 1);
qd=q[.,j];
for i(1, qqn, 1);
qqd=qq[i];
du=(qd.<=qqd);  
xl=selif(x, du); xh=selif(x, (1-du));
yl=selif(y, du); yh=selif(y, (1-du));
el=yl-xl*invpd(xl'xl)*(xl'yl); 
eh=yh-xh*invpd(xh'xh)*(xh'yh);
sil=(el'el)/rows(el); sih=(eh'eh)/rows(eh); 
s[i,j]=rows(el)*ln(det(sil))+rows(eh)*ln(det(sih)); 
endfor; 
endfor; 
 
dhat=minindc(minc(s));  
ghat=qq[minindc(s[.,dhat])];
shat=s[minindc(s[.,dhat]), dhat];

retp(dhat, ghat, shat);
endp; 

proc(4) = twotest(y, x, q, de, r);
local d, el, eh, xl, yl, xh, yh, xxl, xxh, bl, bh;

d=(q[.,de].<=r); 
xl=selif(x, d); xh=selif(x, (1-d));
yl=selif(y, d); yh=selif(y, (1-d));
xxl=invpd(xl'xl); xxh=invpd(xh'xh); 
bl=xxl*(xl'yl); bh=xxh*(xh'yh);
el=yl-xl*bl; eh=yh-xh*bh;
retp (bl, bh, el, eh); 
endp;

proc(1)=sbm (y, x);
local t, tim, tt, ttn, s, ttd, du, xl, xh, yl, yh, el, eh, sil, sih, that;  

t=rows(y); 
tim=seqa(1, 1, t);
tt=trimr(tim, ceil(pr*t), ceil (pr*t));
ttn=rows(tt);
s=zeros(ttn, 1);

for i(1, ttn, 1);
ttd=tt[i];
du=(tim.<=ttd);  
xl=selif(x, du); xh=selif(x, (1-du));
yl=selif(y, du); yh=selif(y, (1-du));
el=yl-xl*invpd(xl'xl)*(xl'yl); 
eh=yh-xh*invpd(xh'xh)*(xh'yh);
sil=(el'el)/rows(el); sih=(eh'eh)/rows(eh); 
s[i]=rows(el)*ln(det(sil))+rows(eh)*ln(det(sih)); 
endfor;  
that=tt[minindc(s)];
retp(that);
endp; 

proc(4)=sbmest(y,x,th);
local k, tim, du, xb, xa, yb, ya, xxb, xxa, bb, ba, eb, ea; 

k=cols(x);
tim=seqa(1,1, rows(y));
du=(tim.<=th);
xb=selif(x, du); xa=selif(x, (1-du));
yb=selif(y, du); ya=selif(y, (1-du));
xxb=invpd(xb'xb); xxa=invpd(xa'xa); 
bb=xxb*(xb'yb); ba=xxa*(xa'ya);
eb=yb-xb*bb; ea=ya-xa*ba;
retp (bb, ba, eb, ea); 
endp;

proc(3)=sbtvarc(y, x, q); 
local t, r, r1, r2,step, tt, st, gat, ddt, qt1, qt2, qt, s, xi1, xi2, yi1, yi2, qi1, qi2;
local q1x, q2x,q1n, q2n,nq, qq1, qq2, qd1, qd2,qqd, du1, xi1l,yi1l, xi1h, yi1h, ui1h, ui1l, sig1l, sig1h; 
local du2, xi2l,yi2l, xi2h, yi2h, ui2h, ui2l, sig2l, sig2h, tf, gh, dh;

t=rows(y);
r1=ceil(pr2*t); 
r2=floor((1-pr2)*t);
step=(r2-r1)/gr;
r=seqa(r1, round(step), gr);
tt=rows(r); 
st=zeros(tt,1); 
ddt=zeros(tt,1); 
gat=zeros(tt,1);
for i(1,tt, 1); 
xi1=x[1:r[i],.]; yi1=y[1:r[i],.]; qi1=q[1:r[i],.]; 
xi2=x[r[i]+1:t,.]; yi2=y[r[i]+1:t,.]; qi2=q[r[i]+1:t,.]; 
qt1=sortc(qi1[.,1],1);
qt1=qt1[(floor(prt*rows(qt1)))+1:ceil((1-prt)*rows(qt1))];
qt2=sortc(qi2[.,1],1);
qt2=qt2[(floor(prt*rows(qt2)))+1:ceil((1-prt)*rows(qt2))];
q1x=maxc(qt1); q1n=minc(qt1);
q2x=maxc(qt2); q2n=minc(qt2);
qq1=minc(q1x|q2x); qq2=maxc(q1n|q2n);
qt=seqa(qq2, (qq1-qq2)/75, 75);
nq=rows(qt); 
s=zeros(nq,cols(q)); 
for j (1, cols(q), 1); 
qd1=qi1[.,j];
qd2=qi2[.,j]; 
for hh (1, nq, 1); 
qqd=qt[hh];
du1=(qd1.<=qqd);
xi1l=selif(xi1,du1); yi1l=selif(yi1,du1); 
xi1h=delif(xi1,du1); yi1h=delif(yi1,du1);
ui1l=yi1l-xi1l*(invpd(xi1l'xi1l)*(xi1l'yi1l));
ui1h=yi1h-xi1h*(invpd(xi1h'xi1h)*(xi1h'yi1h)); 
sig1l=(ui1l'ui1l)./rows(ui1l); sig1h=(ui1h'ui1h)./rows(ui1h);
du2=(qd2.<=qqd);
xi2l=selif(xi2,du2); yi2l=selif(yi2,du2); 
xi2h=delif(xi2,du2); yi2h=delif(yi2,du2);
ui2l=yi2l-xi2l*(invpd(xi2l'xi2l)*(xi2l'yi2l));
ui2h=yi2h-xi2h*(invpd(xi2h'xi2h)*(xi2h'yi2h)); 
sig2l=(ui2l'ui2l)./rows(ui2l); sig2h=(ui2h'ui2h)./rows(ui2h);
s[hh,j]=rows(ui1l)*ln(det(sig1l))+rows(ui1h)*ln(det(sig1h))
      +rows(ui2l)*ln(det(sig2l))+rows(ui2h)*ln(det(sig2h)); 
endfor; 
endfor; 
ddt[i] =minindc(minc(s));  
st[i]=minc(s[.,ddt[i]]);
gat[i]=qt[minindc(s[.,ddt[i]])];
endfor;
tf=r[minindc(st)]; 
dh=ddt[minindc(st)];
gh=gat[minindc(st)];

retp(tf, dh, gh); 
endp; 

proc(5) = tvtvar (y, x, q); 
local t, r1, r2, step, r, rr, ss, resu, xi1, yi1, qi1,qq1, qqr1, qqn1, s1;
local qqd, du, xi1l, yi1l, xi1h, yi1h, xi2l, yi2l, xi2h, yi2h,xi2, yi2,
qi2,qq2, qqr2, qqn2, s2, ui1l, ui2l, ui1h, ui2h, ti1, ti2;   
local sigl, sigh, st, taf, ghat1, ghat2, dhat1, dhat2, qd1, qd2; 

t=rows(y); 
r1=ceil(pr2*t); 
r2=floor((1-pr2)*t);
step=(r2-r1)/gr;
r=seqa(r1, round(step), gr);
rr=rows(r);
ss=zeros(rr,2); 
resu=zeros(rr,4);

/*search over time */ 
for i (1, rr,1);
/*the lower part */
xi1=x[1:r[i],.]; yi1=y[1:r[i],.]; qi1=q[1:r[i],.]; 
ti1=rows(yi1);
qq1=sortc(qi1[.,1],1);
qqr1=trimr(qq1, ceil(prt*ti1), ceil ((prt)*ti1));
qqn1=rows(qqr1);
s1=zeros(qqn1, dmax);
for k (1,dmax,1);
qd1=qi1[.,k]; 
for j (1, qqn1, 1);
qqd=qqr1[j];
du=(qd1.<=qqd);  
xi1l=selif(xi1,du); yi1l=selif(yi1,du); 
xi1h=delif(xi1,du); yi1h=delif(yi1,du);
ui1l=yi1l-xi1l*(invpd(xi1l'xi1l)*(xi1l'yi1l));
ui1h=yi1h-xi1h*(invpd(xi1h'xi1h)*(xi1h'yi1h)); 
sigl=(ui1l'ui1l)./rows(ui1l); sigh=(ui1h'ui1h)./rows(ui1h);
s1[j,k]=-rows(ui1l)*ln(det(sigl))-rows(ui1h)*ln(det(sigh));
endfor;
endfor;
resu[i,1] =maxindc(maxc(s1)); /*dhat1*/
ss[i,1]=maxc(s1[.,resu[i,1]]);
resu[i,2]=qqr1[maxindc(s1[.,resu[i,1]])]; /*ghat1*/

/*the upper part */
xi2=x[r[i]+1:t,.]; yi2=y[r[i]+1:t,.]; qi2=q[r[i]+1:t,.]; 
ti2=rows(yi2);
qq2=sortc(qi2[.,1],1);
qqr2=trimr(qq2, ceil(prt*ti2), ceil ((prt)*ti2));
qqn2=rows(qqr2);
s2=zeros(qqn2, dmax);
for l (1, dmax, 1); 
qd2=qi2[.,l];
for h (1, qqn2,1);
qqd=qqr2[h];
du=(qd2.<=qqd);  
xi2l=selif(xi2,du); yi2l=selif(yi2,du); 
xi2h=delif(xi2,du); yi2h=delif(yi2,du);
ui2l=yi2l-xi2l*(invpd(xi2l'xi2l)*(xi2l'yi2l));
ui2h=yi2h-xi2h*(invpd(xi2h'xi2h)*(xi2h'yi2h)); 
sigl=(ui2l'ui2l)./rows(ui2l); sigh=(ui2h'ui2h)./rows(ui2h);
s2[h,l]=-rows(ui2l)*ln(det(sigl))-rows(ui2h)*ln(det(sigh));
endfor; endfor; 
resu[i,3]=maxindc(maxc(s2)); /*dhat2*/  
ss[i,2]=maxc(s2[.,resu[i,3]]);
resu[i,4]=qqr2[maxindc(s2[.,resu[i,3]])]; /*ghat2*/
endfor; 
st= ss[.,1]+ss[.,2];
taf=r[maxindc(st)];
 
ghat1=resu[maxindc(st),2];
ghat2=resu[maxindc(st),4];
dhat1=resu[maxindc(st),1];
dhat2=resu[maxindc(st),3];

retp(taf, ghat1, ghat2, dhat1, dhat2); 
endp;


proc ginv(m);
local mi;
trap 1;
mi=invpd(m);
if scalerr(mi);
mi=pinv(m);
endif;
if scalerr(mi);
trap 0;
mi=invswp(m);
endif;
retp(mi);
endp;

proc(1) = twotestdp(y0, dh, r, bl, bh, el, eh);
local rri, ysi, ui, vli, vhi, xh1, yei, xei, qei, qi, qq, qqn, s;
local qqd,du, xl, yl, xh, yh, eel, eeh, sil, sih, rl, ru, ci; 

rri=zeros(rep,1);
for j (1, rep, 1);
ysi=zeros(dmax+nn,2);
ysi[1:dmax,.]=y0;
ui=rndu(nn,1); 
vli=el[floor(rows(el)*ui)+1,.];
vhi=eh[floor(rows(eh)*ui)+1,.]; 
for i (dmax+1, nn+dmax, 1);
xh1=xmatrix2(ysi[1:i-1,.],phat);
ysi[i,.]=(((xh1*bl)+vli[i-dmax,.]).*(ysi[i-dh, 2].<=r))+
	     (((xh1*bh)+vhi[i-dmax,.]).*(ysi[i-dh, 2].>r));
endfor;
yei=ysi[dmax+1:nn+dmax,.];
xei=xmatrix(ysi,phat);
qei=ysi[dmax+1-dh:nn+dmax-dh,2];  
qi=sortc(qei,1);
qq=trimr(qi, ceil(pr*nn), ceil (pr*nn));
qqn=rows(qq);
s=zeros(qqn, 1);
for i(1, qqn, 1);
qqd=qq[i];
du=(qei.<=qqd);  
xl=selif(xei, du); xh=delif(xei, du);
yl=selif(yei, du); yh=delif(yei, du);
eel=yl-xl*invpd(xl'xl)*(xl'yl); 
eeh=yh-xh*invpd(xh'xh)*(xh'yh);
sil=(eel'eel)./rows(eel); sih=(eeh'eeh)./rows(eeh); 
s[i]=rows(eel)*ln(det(sil))+rows(eeh)*ln(det(sih)); 
endfor; 
rri[j]=qq[minindc(s)];
endfor;  
rri=sortc(rri,1);
rl=rri[floor(rep*.05)+1];
ru=rri[floor(rep*.95)+1]; 
ci=rl~ru; 

retp (ci); 
endp;


proc(1) = sbmdp(y0, taf, bb, ba, eb, ea);
local rri, ysi, ui, vli, vhi, xh1, yei, xei, tti, qi, tt, ttn, s;
local qqd,du, xl, yl, xh, yh, eel, eeh, sil, sih, rl, ru, ci, tu; 

rri=zeros(rep,1);
for j (1, rep, 1);
ysi=zeros(dmax+nn,2);
ysi[1:dmax,.]=y0;
ui=rndu(nn,1); 
vli=eb[floor(rows(eb)*ui)+1,.];
vhi=ea[floor(rows(ea)*ui)+1,.]; 
for i (dmax+1, nn+dmax, 1);
tu=i-dmax;
xh1=xmatrix2(ysi[1:i-1,.],phat);
ysi[i,.]=(((xh1*bb)+vli[i-dmax,.]).*(tu.<=taf))+
	     (((xh1*ba)+vhi[i-dmax,.]).*(tu.>taf));
endfor;
yei=ysi[dmax+1:nn+dmax,.];
xei=xmatrix(ysi,phat);
tti=seqa(1, 1, nn);  
tt=trimr(tti, ceil(pr*nn), ceil (pr*nn));
ttn=rows(tt);
s=zeros(ttn, 1);
for i(1, ttn, 1);
qqd=tt[i];
du=(tti.<=qqd);  
xl=selif(xei, du); xh=delif(xei, du);
yl=selif(yei, du); yh=delif(yei, du);
eel=yl-xl*invpd(xl'xl)*(xl'yl); 
eeh=yh-xh*invpd(xh'xh)*(xh'yh);
sil=(eel'eel)./rows(eel); sih=(eeh'eeh)./rows(eeh); 
s[i]=rows(eel)*ln(det(sil))+rows(eeh)*ln(det(sih)); 
endfor; 
rri[j]=tt[minindc(s)];
endfor;  
rri=sortc(rri,1);
rl=rri[floor(rep*.05)+1];
ru=rri[floor(rep*.95)+1]; 
ci=rl~ru; 

retp (ci); 
endp;

proc(1)=tvtvardp(y0,taf,dh1,dh2,rh1,rh2,blb,bhb,bla,bha,elb,ehb,ela,eha);
local rri, ysi, ui, vlbi, vhbi, vlai, vhai, tu, xh1, yei, xei, qei;
local r1, r2, step, r, rr, ss, resu, xi1, yi1, qi1,qq1, qqr1, qqn1, s1;
local qqd, du, xi1l, yi1l, xi1h, yi1h, xi2l, yi2l, xi2h, yi2h,xi2, yi2,
qi2,qq2, qqr2, qqn2, s2, ui1l, ui2l, ui1h, ui2h, ti1, ti2, c;   
local sigl, sigh, st, th, gh1, gh2, rri1, rl1, ru1, rri2, rl2, ru2, rri3, rl3, ru3;

rri=zeros(rep,3);
for j (1, rep, 1);
ysi=zeros(dmax+nn,2);
ysi[1:dmax,.]=y0;
ui=rndu(nn,1); 
vlbi=elb[floor(rows(elb)*ui)+1,.];
vhbi=ehb[floor(rows(ehb)*ui)+1,.];
vlai=ela[floor(rows(ela)*ui)+1,.];
vhai=eha[floor(rows(eha)*ui)+1,.];
for i (dmax+1, nn+dmax, 1);
tu=i-dmax;
xh1=xmatrix2(ysi[1:i-1,.],phat);
ysi[i,.]=(((xh1*blb+vlbi[i-dmax,.]).*(ysi[i-dh1,2].<=rh1))+
          ((xh1*bhb+vhbi[i-dmax,.]).*(ysi[i-dh1,2].>rh1))).*(tu.<=taf)+
          (((xh1*bla+vlai[i-dmax,.]).*(ysi[i-dh2,2].<=rh2))+
          ((xh1*bha+vhai[i-dmax,.]).*(ysi[i-dh2,2].>rh2))).*(tu.>taf);
endfor;

yei=ysi[dmax+1:nn+dmax,.];
xei=xmatrix(ysi,phat);
qei=ysi[dmax+1-dh1:nn+dmax-dh1,2];  

r1=ceil(pr2*nn); 
r2=floor((1-pr2)*nn);
step=(r2-r1)/(.4*nn);
r=seqa(r1,step, (.4*nn));
rr=rows(r);
ss=zeros(rr,2); 
resu=zeros(rr,2);

/*search over time */ 
for i (1, rr, 1);
/*the lower part */
xi1=xei[1:r[i],.]; yi1=yei[1:r[i],.]; qi1=qei[1:r[i],.]; 
ti1=rows(xi1); 
/*the threshold estimation */
qq1=sortc(qi1[.,1],1);
qqr1=trimr(qq1, ceil(prt*ti1), ceil (prt*ti1));
qqn1=rows(qqr1);
s1=zeros(qqn1, 1);
for jj (1, qqn1,1);   
qqd=qqr1[jj];
du=(qi1.<=qqd);  
xi1l=selif(xi1,du); yi1l=selif(yi1,du); 
xi1h=delif(xi1,du); yi1h=delif(yi1,du);
ui1l=yi1l-xi1l*(invpd(xi1l'xi1l)*(xi1l'yi1l));
ui1h=yi1h-xi1h*(invpd(xi1h'xi1h)*(xi1h'yi1h)); 
sigl=(ui1l'ui1l)./rows(ui1l); sigh=(ui1h'ui1h)./rows(ui1h);
s1[jj]=-rows(ui1l)*ln(det(sigl))-rows(ui1h)*ln(det(sigh));
endfor; 
ss[i,1]=maxc(s1);
resu[i,1]=qqr1[maxindc(s1)]; /*ghat1*/
/*the upper part */
xi2=xei[r[i]+1:nn,.]; yi2=yei[r[i]+1:nn,.]; qi2=qei[r[i]+1:nn,.]; 
ti2=rows(xi2); 
/*the threshold estimation */
qq2=sortc(qi2[.,1],1);
qqr2=trimr(qq2, ceil(prt*ti2), ceil (prt*ti2));
qqn2=rows(qqr2);
s2=zeros(qqn2,1);
for o (1, qqn2, 1);
qqd=qqr2[o];
du=(qi2.<=qqd);  
xi2l=selif(xi2,du); yi2l=selif(yi2,du); 
xi2h=delif(xi2,du); yi2h=delif(yi2,du);
ui2l=yi2l-xi2l*(invpd(xi2l'xi2l)*(xi2l'yi2l));
ui2h=yi2h-xi2h*(invpd(xi2h'xi2h)*(xi2h'yi2h)); 
sigl=(ui2l'ui2l)./rows(ui2l); sigh=(ui2h'ui2h)./rows(ui2h);
s2[o]=-rows(ui2l)*ln(det(sigl))-rows(ui2h)*ln(det(sigh));
endfor; 
ss[i,2]=maxc(s2);
resu[i,2]=qqr2[maxindc(s2)]; /*ghat2*/
endfor; 
st= ss[.,1]+ss[.,2];
th=r[maxindc(st)];
gh1=resu[maxindc(st),1];
gh2=resu[maxindc(st),2];
rri[j,.]=th~gh1~gh2;
endfor;

rri1=sortc(rri[.,1],1);
rl1=rri1[floor(rep*.05)+1];
ru1=rri1[floor(rep*.95)+1]; 
rri2=sortc(rri[.,2],1);
rl2=rri2[floor(rep*.05)+1];
ru2=rri2[floor(rep*.95)+1]; 
rri3=sortc(rri[.,3],1);
rl3=rri3[floor(rep*.05)+1];
ru3=rri3[floor(rep*.95)+1]; 
c=(rl1~ru1)|(rl2~ru2)|(rl3~ru3); 
retp(c); 
endp;


proc(1)=jointdp(y0,taf,dh,rh,blb,bhb,bla,bha,elb,ehb,ela,eha);
local rri, ysi, ui, vlbi, vhbi, vlai, vhai, tu, xh1, yei, xei, qei;
local  th, gh, rri1, rl1, ru1, rri2, rl2, ru2, tim;
local du1, du2, xi1l, xi1h, yi1l, yi1h, xi2l, xi2h, yi2l, yi2h,ui1l,ui1h, ui2l, ui2h, sig1l, sig1h, sig2l, sig2h;   
local r1, r2, step, r, rr, st, gat, dt, tp, qt1, qt2, qt, s,qq1, qq2,
qd, qqd, q1x, q1n, q2x, q2n,qq, xi1, yi1, xi2, yi2,qi1, qi2, nq, c;

rri=zeros(rep,2);
for j (1, rep, 1);
ysi=zeros(dmax+nn,2);
ysi[1:dmax,.]=y0;
ui=rndu(nn,1); 
vlbi=elb[floor(rows(elb)*ui)+1,.];
vhbi=ehb[floor(rows(ehb)*ui)+1,.];
vlai=ela[floor(rows(ela)*ui)+1,.];
vhai=eha[floor(rows(eha)*ui)+1,.];
for i (dmax+1, nn+dmax, 1);
tu=i-dmax;
xh1=xmatrix2(ysi[1:i-1,.],phat);
ysi[i,.]=(((xh1*blb+vlbi[i-dmax,.]).*(ysi[i-dh,2].<=rh))+
          ((xh1*bhb+vhbi[i-dmax,.]).*(ysi[i-dh,2].>rh))).*(tu.<=taf)+
          (((xh1*bla+vlai[i-dmax,.]).*(ysi[i-dh,2].<=rh))+
          ((xh1*bha+vhai[i-dmax,.]).*(ysi[i-dh,2].>rh))).*(tu.>taf);
endfor;

yei=ysi[dmax+1:nn+dmax,.];
xei=xmatrix(ysi,phat);
qei=ysi[dmax+1-dh:nn+dmax-dh,2];
tim=seqa(1, 1, nn);

r1=ceil(pr2*nn); 
r2=floor((1-pr2)*nn);
step=(r2-r1)/(.4*nn);
r=seqa(r1,step, (.4*nn));
rr=rows(r);
st=zeros(rr,1); 
gat=zeros(rr,1);

for i(1,rr, 1);
tp=r[i];
dt=tim.<=tp;
xi1=xei[1:r[i],.];    yi1=yei[1:r[i],.];    qi1=qei[1:r[i],.]; 
xi2=xei[r[i]+1:nn,.]; yi2=yei[r[i]+1:nn,.]; qi2=qei[r[i]+1:nn,.];
qt1=sortc(qi1[.,1],1);
qt1=qt1[(floor((prt)*rows(qt1)))+1:ceil((1-(prt))*rows(qt1))];
qt2=sortc(qi2[.,1],1);
qt2=qt2[(floor((prt)*rows(qt2)))+1:ceil((1-(prt))*rows(qt2))];
q1x=maxc(qt1); q1n=minc(qt1);
q2x=maxc(qt2); q2n=minc(qt2);
qq1=minc(q1x|q2x); qq2=maxc(q1n|q2n);
qt=seqa(qq2, (qq1-qq2)/75, 75);
nq=rows(qt); 
s=zeros(nq,1);
for hh (1, nq, 1); 
qqd=qt[hh];
du1=(qi1.<=qqd);
xi1l=selif(xi1,du1); yi1l=selif(yi1,du1); 
xi1h=delif(xi1,du1); yi1h=delif(yi1,du1);
ui1l=yi1l-xi1l*(invpd(xi1l'xi1l)*(xi1l'yi1l));
ui1h=yi1h-xi1h*(invpd(xi1h'xi1h)*(xi1h'yi1h)); 
sig1l=(ui1l'ui1l)./rows(ui1l); sig1h=(ui1h'ui1h)./rows(ui1h);
du2=(qi2.<=qqd);
xi2l=selif(xi2,du2); yi2l=selif(yi2,du2); 
xi2h=delif(xi2,du2); yi2h=delif(yi2,du2);
ui2l=yi2l-xi2l*(invpd(xi2l'xi2l)*(xi2l'yi2l));
ui2h=yi2h-xi2h*(invpd(xi2h'xi2h)*(xi2h'yi2h)); 
sig2l=(ui2l'ui2l)./rows(ui2l); sig2h=(ui2h'ui2h)./rows(ui2h);
s[hh]=rows(ui1l)*ln(det(sig1l))+rows(ui1h)*ln(det(sig1h))
      +rows(ui2l)*ln(det(sig2l))+rows(ui2h)*ln(det(sig2h)); 
endfor; 
st[i]=minc(s);
gat[i]=qt[minindc(s)];
endfor;
th=r[minindc(st)]; 
gh=gat[minindc(st)];
rri[j,.]=th~gh;
endfor;

rri1=sortc(rri[.,1],1);
rl1=rri1[floor(rep*.05)+1];
ru1=rri1[floor(rep*.95)+1]; 
rri2=sortc(rri[.,2],1);
rl2=rri2[floor(rep*.05)+1];
ru2=rri2[floor(rep*.95)+1]; 
c=(rl1~ru1)|(rl2~ru2); 
retp(c); 
endp;


proc(1)=xmatrix2(y, p); 
local x, xx, i, j;  
x=ones(1, 1);
i=1; do while i<=l;
xx=y[.,i];
j=1; do while j<=p; 
x=x~xx[rows(xx)-j+1];
j=j+1; endo; i=i+1;endo;    
retp(x); 
endp; 


proc(6)=threest3(y, x, q); 
local dh, gh, qd, gh1, gh2, d1, d2, x3, xx3, e, shat1, shat2, ghatr, d, x2, xx2; 

{dh, gh, shat1}=threest(y, x, q);
qd=q[.,dh];
d=(qd.<=gh);
x2=(x.*d)~(x.*(1-d));
xx2=ginv(x2'x2);
e=y-x2*xx2*x2'y;
shat1=ln(det(e'e./rows(e)));
{gh2} =threest_d(y, x, qd, gh);
{gh1}=threest_d(y, x, qd, gh2);
{gh2}=threest_d(y, x, qd, gh1);
if gh1>gh2; ghatr=gh2; gh2=gh1; gh1=ghatr; endif;
d1=(qd.<=gh1);
d2=(qd.<=gh2).*(1-d1);
x3=(x.*d1)~(x.*d2)~(x.*(1-d1-d2));
xx3=ginv(x3'x3);
e=y-x3*xx3*x3'y;
shat2=ln(det(e'e./rows(e)));

retp(dhat, gh, gh1, gh2, shat1, shat2);
endp;


proc(1)=threest_d(y, x, qd, gh);
local t,  qq, n1, qqs, qqn, s, xx, el, qqd, d, dd, xg;
local ghat, x1, k, eg, ieg, elg; 

t=rows(x);
k=cols(x); 
qq=unique(qd,1);
n1=ceil(pr*rows(qq));
qq=qq[n1:(rows(qq)-n1+1)];
qqs=delif(qq,(abs(seqa(1,1,rows(qq))-maxindc(qq.>=gh)).<n1));
qqs=packr(qqs);
qqn=rows(qqs); 
s=zeros(qqn, 1);
 
xx=ginv(x'x);
el=y- x*xx*(x'y);
x1=(x.*(qd.<=gh)); 
 
for i(1, qqn, 1);
qqd=qqs[i];
d=(qd.<=qqd);  
xg=x1~(x.*d);
eg=xg-(x*xx*(x'xg));
ieg=ginv(eg'eg); 
elg=el-(eg*ieg*(eg'el)); 
s[i]=ln(det(vcx(elg)));
endfor; 

ghat=qqs[minindc(s)];
retp(ghat);
endp; 

proc(2)=sbm2(y, x); 
local th, th2, th1, ghatr;

{th}=sbm(y, x);
{th2}=sbm_d(y, x, th);
{th1}=sbm_d(y, x, th2);
{th2}=sbm_d(y, x, th1);
if th1>th2; ghatr=th2; th2=th1; th1=ghatr; endif;

retp(th1,th2);
endp;


proc(1)=sbm_d(y, x, th);
local t, tim, n1, tt, tts, ttn, xx, el, x1, td, d, xg,eg,ieg,elg,s,that; 

t=rows(y); 
tim=seqa(1, 1, t);
n1=ceil(pr*rows(qq));
tt=tim[n1:(rows(qq)-n1+1)];
tts=delif(tt,(abs(seqa(1,1,rows(tt))-maxindc(tt.>=th)).<n1));
ttn=rows(tts); 
s=zeros(ttn, 1);
 
xx=ginv(x'x);
el=y- x*xx*(x'y);
x1=(x.*(tim.<=th)); 
 
for i(1, ttn, 1);
td=tts[i];
d=(tim.<=td);  
xg=x1~(x.*d);
eg=xg-(x*xx*(x'xg));
ieg=ginv(eg'eg); 
elg=el-(eg*ieg*(eg'el)); 
s[i]=ln(det((elg'elg)./rows(elg)));
endfor; 

that=tts[minindc(s)];
retp(that);
endp; 
