/* this is a new code to do real time evalution, including forecasting*/
/* This code also generates in-sample forecasts*/
/* models: VAR, TVAR, SBVAR, SBVARc, SBTVAR*/
/*Written by Ana Beatriz Galvao*/
/*december, 2003*/

new;

load y[203,73]=datar.csv;
load pp[203,2]=dataev.csv;
output file=newfor.out reset;
format /mb1 /rdc 8,4;

/*number of endogenous variables*/ l=2;
/*autoregressive order */ phat=3;
/*maximum delay order*/ dmax=4;
/*triming for threshold*/pr=.15;
/*triming for the structural break */pr2=.30;
/* triming for sbt model*/prt=.20;
/* grid for sbt*/ gr=.4*(.3*200);
/*first forecast origin*/t0=131; /*1986:1 with data until 1985:4*/
/*number forecast steps*/ h=5;
/*forecast replications*/ rep=1000;
/*out-of-sample size*/ n=72;

proba=zeros(n,5);
probb=zeros(n,5);
probain=zeros(n,5);
probbin=zeros(n,5);
ksi=zeros(n,5*4);
param=zeros(n,11);

/* using real-time data for forecasting probability of recession*/
for ni (1, n, 1);
if ni==25 or ni==26 or ni==27 or ni==28 or ni==56 or ni==57;
yi=(100*(ln(y[26:t0+ni,ni+1])-ln(y[25:t0+ni-1,ni+1])))~y[26:t0+ni,1];
y0=yi[rows(yi)-dmax+1:rows(yi),.];
ppi=pp[25:t0+ni,.]; 
elseif ni==41 or ni==42 or ni==43 or ni==44 or ni==45;
yi=(100*(ln(y[28:t0+ni,ni+1])-ln(y[27:t0+ni-1,ni+1])))~y[28:t0+ni,1];
y0=yi[rows(yi)-dmax+1:rows(yi),.];
ppi=pp[27:t0+ni,.];
else;
yi=(100*(ln(y[2:t0+ni,ni+1])-ln(y[1:t0+ni-1,ni+1])))~y[2:t0+ni,1];
y0=yi[rows(yi)-dmax+1:rows(yi),.];
ppi=pp[1:t0+ni,.];endif; 


/*organizing data*/
nn=rows(yi);
q=yi[.,2];
qq=zeros(nn-dmax, 1); 
j=1; do while j<=dmax; 
qq=qq~q[1+dmax-j:nn-j];
j=j+1; endo; 
qe=qq[.,2:dmax+1];
ye=trimr(yi, dmax, 0); 
xe=xmatrix(yi,phat);
nn=rows(ye);

/* VAR*/
/*estimation*/
b_var=invpd(xe'xe)*(xe'ye);
e_var=ye-(xe*b_var);
/*in-sample*/
fim=nn+dmax-4;
beg=nn+dmax-4-(4*15);/*window of 15 years*/
prc=zeros(fim-beg,2); 
for j (beg+1, fim, 1);
y0f=yi[j-dmax:j-1,.];
{yvar, pvar}=forvar(y0f, b_var, e_var);
prc[j-beg,.]=pvar';
endfor;
y0f=yi[rows(yi)-dmax:rows(yi)-1,.];
{yvar, pvar}=forvar(y0f, b_var, e_var);
probain[ni,1]=pvar[1];
probbin[ni,1]=pvar[2];
{ksc}=ksav(prc, ppi[beg+2:rows(ppi)-4,.]);/*+2 because of no dif*/
ksi[ni,1:4]=ksc;
/*out-of-sample*/
{yvar, pvar}=forvar(y0, b_var, e_var);
proba[ni,1]=pvar[1];
probb[ni,1]=pvar[2];

/*TVAR*/
/*estimation*/
{dhat, rhat, shat}=threest(ye, xe, qe);
{bl2, bh2, el2, eh2}=twotest(ye, xe, qe, dhat, rhat);
/*in-sample*/
fim=nn+dmax-4;
beg=nn+dmax-4-(4*15);/*window of 15 years*/
prc=zeros(fim-beg,2);
for j (beg+1, fim, 1);
y0f=yi[j-dmax:j-1,.];
{ytvar, ptvar}=fortvar(y0f, dhat, rhat, bl2, bh2, el2, eh2);
prc[j-beg,.]=ptvar';
endfor;
y0f=yi[rows(yi)-dmax:rows(yi)-1,.];
{ytvar, ptvar}=fortvar(y0f, dhat, rhat, bl2, bh2, el2, eh2);
probain[ni,2]=ptvar[1];
probbin[ni,2]=ptvar[2];
{ksc}=ksav(prc, ppi[beg+2:rows(ppi)-4,.]);
ksi[ni,5:8]=ksc;
/*out-of-sample*/
{ytvar, ptvar}=fortvar(y0,dhat, rhat, bl2, bh2, el2, eh2); 
proba[ni,2]=ptvar[1];
probb[ni,2]=ptvar[2];
param[ni,1:2]=dhat~rhat; 

/* SBVAR*/
/*estimation*/
{that}=sbm(ye,xe);
{bbt, bat, ebt, eat} =sbmest(ye,xe,that);
/*in-sample*/
fim=nn+dmax-4;
beg=nn+dmax-4-(4*15);/*window of 15 years*/
prc=zeros(fim-beg,2); 
for j (beg+1, fim, 1);
y0f=yi[j-dmax:j-1,.];
if (j-1-dmax)>that;
{ysbvar, psbvar}=forvar(y0f, bat, eat);
prc[j-beg,.]=psbvar';
else;
{ysbvar, psbvar}=forvar(y0f, bbt, ebt);
prc[j-beg,.]=psbvar';
endif;
endfor;
y0f=yi[rows(yi)-dmax:rows(yi)-1,.];
{ysbvar, psbvar}=forvar(y0f, bat, eat);
probain[ni,3]=psbvar[1];
probbin[ni,3]=psbvar[2];
{ksc}=ksav(prc, ppi[beg+2:rows(ppi)-4,.]);
ksi[ni,9:12]=ksc;
/*out-of-sample*/
{ysbvar, psbvar}=forvar(y0,bat, eat); 
proba[ni,3]=psbvar[1];
probb[ni,3]=psbvar[2];
if ni==25 or ni==26 or ni==27 or ni==28 or ni==56 or ni==57;
param[ni,3]=(((that+dmax+26)/4)+(1953+0.25));
elseif ni==41 or ni==42 or ni==43 or ni==44 or ni==45;
param[ni,3]=(((that+dmax+28)/4)+(1953+0.25));
else; 
param[ni,3]=(((that+dmax)/4)+(1953+0.25));
endif; 

/*SBTVARc*/
/*estimation*/
{thatc,dhatc,ghatc}=sbtvarc(ye, xe, qe);
ysb=selif(ye, seqa(1,1,rows(ye)).>thatc);
xsb=selif(xe, seqa(1,1,rows(ye)).>thatc);
qsb=selif(qe, seqa(1,1,rows(ye)).>thatc);
{bla10, bha10, ela10, eha10}=twotest(ysb, xsb, qsb, dhatc, ghatc);
ysb=delif(ye, seqa(1,1,rows(ye)).>thatc);
xsb=delif(xe, seqa(1,1,rows(ye)).>thatc);
qsb=delif(qe, seqa(1,1,rows(ye)).>thatc);
{blb10, bhb10, elb10, ehb10}=twotest(ysb, xsb, qsb, dhatc, ghatc);
/*in-sample*/
fim=nn+dmax-4;
beg=nn+dmax-4-(4*15);/*window of 15 years*/
prc=zeros(fim-beg,2); 
for j (beg+1, fim, 1);
y0f=yi[j-dmax:j-1,.];
if (j-1-dmax)>thatc;
{ysbtvarc, psbtvarc}=fortvar(y0f, dhatc, ghatc, bla10, bha10, ela10, eha10);
prc[j-beg,.]=psbtvarc';
else;
{ysbtvarc, psbtvarc}=fortvar(y0f, dhatc, ghatc, blb10, bhb10, elb10, ehb10);
prc[j-beg,.]=psbtvarc';
endif;
endfor;
y0f=yi[rows(yi)-dmax:rows(yi)-1,.];
{ysbtvarc, psbtvarc}=fortvar(y0f, dhatc, ghatc, bla10, bha10, ela10, eha10);
probain[ni,4]=psbtvarc[1];
probbin[ni,4]=psbtvarc[2];
{ksc}=ksav(prc, ppi[beg+2:rows(ppi)-4,.]);
ksi[ni,13:16]=ksc;
/*out-of-sample*/
{ysbtvarc, psbtvarc}=fortvar(y0,dhatc, ghatc, bla10, bha10, ela10, eha10); 
proba[ni,4]=psbtvarc[1];
probb[ni,4]=psbtvarc[2];
if ni==25 or ni==26 or ni==27 or ni==28 or ni==56 or ni==57;
param[ni,4:6]=(((thatc+dmax+26)/4)+(1953+0.25))~dhatc~ghatc;
elseif ni==41 or ni==42 or ni==43 or ni==44 or ni==45;
param[ni,4:6]=(((thatc+dmax+28)/4)+(1953+0.25))~dhatc~ghatc;
else; 
param[ni,4:6]=(((thatc+dmax)/4)+(1953+0.25))~dhatc~ghatc;
endif; 

/*SBTVAR*/
/*estimation*/
{thatt, ghat1, ghat2, dhat1, dhat2}=tvtvar (ye, xe, qe);
ysb=selif(ye, seqa(1,1,rows(ye)).>thatt);
xsb=selif(xe, seqa(1,1,rows(ye)).>thatt);
qsb=selif(qe, seqa(1,1,rows(ye)).>thatt);
{bla12, bha12, ela12, eha12}=twotest(ysb, xsb, qsb, dhat2, ghat2);
ysb=delif(ye, seqa(1,1,rows(ye)).>thatt);
xsb=delif(xe, seqa(1,1,rows(ye)).>thatt);
qsb=delif(qe, seqa(1,1,rows(ye)).>thatt);
{blb12, bhb12, elb12, ehb12}=twotest(ysb, xsb, qsb, dhat1, ghat1);
/*in-sample*/
fim=nn+dmax-4;
beg=nn+dmax-4-(4*15);/*window of 15 years*/
prc=zeros(fim-beg,2); 
for j (beg+1, fim, 1);
y0f=yi[j-dmax:j-1,.];
if (j-1-dmax)>thatt;
{ysbtvarc, psbtvarc}=fortvar(y0f, dhat2, ghat2, bla12, bha12, ela12, eha12);
prc[j-beg,.]=psbtvarc';
else;
{ysbtvarc, psbtvarc}=fortvar(y0f, dhat1, ghat1, blb12, bhb12, elb12, ehb12);
prc[j-beg,.]=psbtvarc';
endif;
endfor;
y0f=yi[rows(yi)-dmax:rows(yi)-1,.];
{ysbtvarc, psbtvarc}=fortvar(y0f, dhat2, ghat2, bla12, bha12, ela12, eha12);
probain[ni,5]=psbtvarc[1];
probbin[ni,5]=psbtvarc[2];
{ksc}=ksav(prc,ppi[beg+2:rows(ppi)-4,.]);
ksi[ni,17:20]=ksc;
/*out-of-sample*/
{ysbtvarc, psbtvarc}=fortvar(y0,dhat2, ghat2, bla12, bha12, ela12, eha12); 
proba[ni,5]=psbtvarc[1];
probb[ni,5]=psbtvarc[2];
if ni==25 or ni==26 or ni==27 or ni==28 or ni==56 or ni==57;
param[ni,7:11]=(((thatt+dmax+26)/4)+(1953+0.25))~dhat1~ghat1~dhat2~ghat2;
elseif ni==41 or ni==42 or ni==43 or ni==44 or ni==45;
param[ni,7:11]=(((thatt+dmax+28)/4)+(1953+0.25))~dhat1~ghat1~dhat2~ghat2;
else; 
param[ni,7:11]=(((thatt+dmax)/4)+(1953+0.25))~dhat1~ghat1~dhat2~ghat2;
endif; 

print ni; 
endfor; 

"parameters of TVAR, SBVAR and SBTVARc";
print param[.,1:6];
"parameters of SBTVAR";
print param[.,7:11];
"forecasting of probability of event a";
print proba;
"forecasting of probability of event b";
print probb;
"Kuipers score and cutt point for VAR";
print ksi[.,1:4];
"Kuipers score and cutt point for TVAR";
print ksi[.,5:8];
"Kuipers score and cutt point for SBVAR";
print ksi[.,9:12];
"Kuipers score and cutt point for SBTVARc";
print ksi[.,13:16];
"Kuipers score and cutt point for SBTVAR";
print ksi[.,17:20];
"forecasting of probability of event a - in-sample";
print probain;
"forecasting of probability of event b - in-sample";
print probbin;

/*in-sample forecasts for all sample*/
yi=(100*(ln(y[2:t0+n,n+1])-ln(y[1:t0+n-1,n+1])))~y[2:t0+n,1];
/*organizing data*/
nn=rows(yi);
q=yi[.,2];
qq=zeros(nn-dmax, 1); 
j=1; do while j<=dmax; 
qq=qq~q[1+dmax-j:nn-j];
j=j+1; endo; 
qe=qq[.,2:dmax+1];
ye=trimr(yi, dmax, 0); 
xe=xmatrix(yi,phat);
nn=rows(ye);

b_var=invpd(xe'xe)*(xe'ye);
e_var=ye-(xe*b_var);
probin=zeros(nn,5);
for j (dmax+1, dmax+nn, 1);
y0=yi[j-dmax:j-1,.];
{yvar, pvar}=forvar(y0, b_var, e_var);
probin[j-dmax,1]=pvar[2];
endfor;
{dhat, rhat, shat}=threest(ye, xe, qe);
{bl2, bh2, el2, eh2}=twotest(ye, xe, qe, dhat, rhat);
for j (dmax+1, dmax+nn, 1);
y0=yi[j-dmax:j-1,.];
{ytvar, ptvar}=fortvar(y0, dhat, rhat, bl2, bh2, el2, eh2);
probin[j-dmax,2]=ptvar[2];
endfor;
{that}=sbm(ye,xe);
{bbt, bat, ebt, eat} =sbmest(ye,xe,that);
for j (dmax+1, dmax+nn, 1);
y0f=yi[j-dmax:j-1,.];
if (j-1-dmax)>that;
{ysbvar, psbvar}=forvar(y0f, bat, eat);
probin[j-dmax,3]=psbvar[2];
else;
{ysbvar, psbvar}=forvar(y0f, bbt, ebt);
probin[j-dmax,3]=psbvar[2];
endif;
endfor;
{thatc,dhatc,ghatc}=sbtvarc(ye, xe, qe);
ysb=selif(ye, seqa(1,1,rows(ye)).>thatc);
xsb=selif(xe, seqa(1,1,rows(ye)).>thatc);
qsb=selif(qe, seqa(1,1,rows(ye)).>thatc);
{bla10, bha10, ela10, eha10}=twotest(ysb, xsb, qsb, dhatc, ghatc);
ysb=delif(ye, seqa(1,1,rows(ye)).>thatc);
xsb=delif(xe, seqa(1,1,rows(ye)).>thatc);
qsb=delif(qe, seqa(1,1,rows(ye)).>thatc);
{blb10, bhb10, elb10, ehb10}=twotest(ysb, xsb, qsb, dhatc, ghatc);
for j (dmax+1, dmax+nn, 1);
y0f=yi[j-dmax:j-1,.];
if (j-1-dmax)>that;
{ysbtvarc, psbtvarc}=fortvar(y0f, dhatc, ghatc, bla10, bha10, ela10, eha10);
probin[j-dmax,4]=psbtvarc[2];
else;
{ysbtvarc, psbtvarc}=fortvar(y0f, dhatc, ghatc, blb10, bhb10, elb10, ehb10);
probin[j-dmax,4]=psbtvarc[2];
endif;
endfor;
{thatt, ghat1, ghat2, dhat1, dhat2}=tvtvar (ye, xe, qe);
ysb=selif(ye, seqa(1,1,rows(ye)).>thatt);
xsb=selif(xe, seqa(1,1,rows(ye)).>thatt);
qsb=selif(qe, seqa(1,1,rows(ye)).>thatt);
{bla12, bha12, ela12, eha12}=twotest(ysb, xsb, qsb, dhat2, ghat2);
ysb=delif(ye, seqa(1,1,rows(ye)).>thatt);
xsb=delif(xe, seqa(1,1,rows(ye)).>thatt);
qsb=delif(qe, seqa(1,1,rows(ye)).>thatt);
{blb12, bhb12, elb12, ehb12}=twotest(ysb, xsb, qsb, dhat1, ghat1);
for j (dmax+1, dmax+nn, 1);
y0f=yi[j-dmax:j-1,.];
if (j-1-dmax)>that;
{ysbtvarc, psbtvarc}=fortvar(y0f, dhat2, ghat2, bla12, bha12, ela12, eha12);
probin[j-dmax,5]=psbtvarc[2];
else;
{ysbtvarc, psbtvarc}=fortvar(y0f, dhat1, ghat1, blb12, bhb12, elb12, ehb12);
probin[j-dmax,5]=psbtvarc[2];
endif;
endfor;
"in-sample probabilities";
print probin;  
end;
/************************************************************************/
proc(1)=xmatrix(y, p); 
local x, xx, i, j, t; 
t=rows(y)-dmax; 
x=ones(t, 1);
i=1; do while i<=cols(y); 
xx=y[.,i];
j=1; do while j<=p; 
x=x~xx[1+dmax-j:t+dmax-j];
j=j+1; endo;i=i+1;endo;
retp(x); 
endp; 

proc(1)=xmatrix2(y, p); 
local x, xx, i, j;  
x=ones(1, 1);
i=1; do while i<=l;
xx=y[.,i];
j=1; do while j<=p; 
x=x~xx[rows(xx)-j+1];
j=j+1; endo; i=i+1;endo;    
retp(x); 
endp; 

proc(2)=forvar(y0,b,e);
local n1, yy1, u, v, xh1, pro, yy2, yy; 
n1=rows(e);
yy1=zeros(h+dmax, rep);
yy2=zeros(h+dmax, rep);
for j (1, rep, 1);
yy1[1:dmax,j]=y0[.,1];
yy2[1:dmax,j]=y0[.,2];
endfor; 
for j (1, rep, 1); 
u=rndu(h,1); 
v=e[ceil(n1*u),.]; 
for i(dmax+1, h+dmax, 1);
xh1=xmatrix2(yy1[1:i-1,j]~yy2[1:i-1,j],phat);
yy1[i,j]=(xh1*b[.,1]+v[i-dmax,1]);
yy2[i,j]=(xh1*b[.,2]+v[i-dmax,2]);
endfor; 
endfor;
yy=meanc(yy1[dmax+1:h+dmax,.]');
{pro}=probextrac(yy1[dmax:dmax+5,.]');
pro=sumc(pro)./rep;
retp(yy, pro);
endp; 

/* code with t at 2, it is to use past information to date recessions*/
proc(1)=probextrac(data); 
local s, sig, sign, dat, rs;  
s=rows(data);
sig=zeros(s, 2); 
for i (1, s, 1); 
if (data[i,2]<0 and data[i,3]<0) or (data[i,3]<0 and data[i,4]<0) 
or (data[i,4]<0 and data[i,5]<0) or (data[i,5]<0 and data[i,6]<0);
sig[i,1]=1;
else; 
sig[i,1]=0;
endif;
if (data[i,1]<0 and data[i,2]<0) or (data[i,2]<0 and data[i,3]<0);
sig[i,2]=1;
else; 
sig[i,2]=0;
endif;
endfor; 
retp(sig); 
endp; 

proc(1)=ksav(pmo, pdat);
local unco, step1, cc1, cc2, kpm, cutt1, cutt2, re, step2, kuip1, kuip2, ct; 
@unco=sumc(pdat)./rows(pdat);@
step1=(0.6-0.16)/20;
cc1=seqa(0.16, step1, 20);
kpm=zeros(20,1);
for j (1, 20, 1);
cutt1=cc1[j];
{kuip1,ct}=kuipers(pmo[.,1], pdat[.,1], cutt1);
kpm[j]=kuip1;
endfor;
re=cc1[minindc(kpm)]~minc(kpm);
step2=(0.6-0.10)/20;
cc2=seqa(0.10, step2, 20);
kpm=zeros(20,1);
for j (1, 20, 1);
cutt2=cc2[j];
{kuip2,ct}=kuipers(pmo[.,2], pdat[.,2], cutt2);
kpm[j]=kuip2;
endfor;
re=re~cc2[minindc(kpm)]~minc(kpm);
retp(re);
endp;

proc(2)=kuipers(F, r, cut);
local hit, ev1, ev0, fal, nuu, ndu, nud, ndd, ks, ct;

ev1=selif(f, r.==1);
ev0=selif(f, r.==0);
hit=zeros(rows(ev1),1); fal=zeros(rows(ev0),1);

for i (1, rows(ev1), 1);
if ev1[i]>cut; 
hit[i]=1; endif; 
endfor; 
for i (1, rows(ev0), 1);
if ev0[i]>cut;
fal[i]=1; endif; 
endfor;


nuu=sumc(hit); ndu=(rows(ev1))-nuu;
nud=sumc(fal); ndd=(rows(ev0))-nud;
ct=(nuu~nud) | (ndu~ndd);

KS= (nud/(rows(ev1))) - (nuu/(rows(ev1))) ;

retp(ks, ct);
endp;

proc(2)=fortvar(y0, dhat, rhat, bl, bh, el, eh);
local nl, nm, nh, yy2, yy1, e1, e2, e3, vl, vm, vh, yf, pn, std, xh1, yp, pro, yy; 

nl=rows(el); nh=rows(eh);
yy1=zeros(h+dmax, rep);
yy2=zeros(h+dmax, rep); 
for j (1, rep, 1);
yy1[1:dmax,j]=y0[.,1];
yy2[1:dmax,j]=y0[.,2];
endfor; 
for j (1, rep, 1); 
e1=rndu(h,1); e2=rndu(h,1); 
vl=el[ceil(nl*e1),.]; vh=eh[ceil(nh*e2),.];
for i(dmax+1, h+dmax, 1);
xh1=xmatrix2(yy1[1:i-1,j]~yy2[1:i-1,j],phat);
yy1[i,j]=(((xh1*bl[.,1])+vl[i-dmax,1]).*(yy2[i-dhat, j].<=rhat))+
	     (((xh1*bh[.,1])+vh[i-dmax,1]).*(yy2[i-dhat, j].>rhat));
yy2[i,j]=(((xh1*bl[.,2])+vl[i-dmax,2]).*(yy2[i-dhat, j].<=rhat))+
         (((xh1*bh[.,2])+vh[i-dmax,2]).*(yy2[i-dhat, j].>rhat));
endfor; 
endfor; 
yy=meanc(yy1[dmax+1:h+dmax,.]');
{pro}=probextrac(yy1[dmax:dmax+5,.]');
pro=sumc(pro)./rep;
retp(yy,pro);
endp;

 
proc(3)=threest (y, x, q);
local t,k, qi, n1, qq, qqs, qqn, s, qqd, du, xl, xh, yl, yh, el, eh, sil, sih; 
local ghat, d, dhat, shat, qd; 

d=cols(q); 
t=rows(y); 
k=cols(x);
qi=sortc(q[.,1],1);
qq=qi[floor(pr*t)+1:ceil((1-pr)*t)];
qqn=rows(qq);
s=zeros(qqn,d);
 
for j (1, d, 1);
qd=q[.,j];
for i(1, qqn, 1);
qqd=qq[i];
du=(qd.<=qqd);  
xl=selif(x, du); xh=selif(x, (1-du));
yl=selif(y, du); yh=selif(y, (1-du));
el=yl-xl*invpd(xl'xl)*(xl'yl); 
eh=yh-xh*invpd(xh'xh)*(xh'yh);
sil=(el'el)/rows(el); sih=(eh'eh)/rows(eh); 
s[i,j]=rows(el)*ln(det(sil))+rows(eh)*ln(det(sih)); 
endfor; 
endfor; 
 
dhat=minindc(minc(s));  
ghat=qq[minindc(s[.,dhat])];
shat=s[minindc(s[.,dhat]), dhat];

retp(dhat, ghat, shat);
endp; 

proc(4) = twotest(y, x, q, de, r);
local d, el, eh, xl, yl, xh, yh, xxl, xxh, bl, bh;

d=(q[.,de].<=r); 
xl=selif(x, d); xh=selif(x, (1-d));
yl=selif(y, d); yh=selif(y, (1-d));
xxl=invpd(xl'xl); xxh=invpd(xh'xh); 
bl=xxl*(xl'yl); bh=xxh*(xh'yh);
el=yl-xl*bl; eh=yh-xh*bh;
retp (bl, bh, el, eh); 
endp;

proc(1)=sbm (y, x);
local t, tim, tt, ttn, s, ttd, du, xl, xh, yl, yh, el, eh, sil, sih, that;  

t=rows(y); 
tim=seqa(1, 1, t);
tt=trimr(tim, ceil(pr*t), ceil (pr*t));
ttn=rows(tt);
s=zeros(ttn, 1);

for i(1, ttn, 1);
ttd=tt[i];
du=(tim.<=ttd);  
xl=selif(x, du); xh=selif(x, (1-du));
yl=selif(y, du); yh=selif(y, (1-du));
el=yl-xl*invpd(xl'xl)*(xl'yl); 
eh=yh-xh*invpd(xh'xh)*(xh'yh);
sil=(el'el)/rows(el); sih=(eh'eh)/rows(eh); 
s[i]=rows(el)*ln(det(sil))+rows(eh)*ln(det(sih)); 
endfor;  
that=tt[minindc(s)];
retp(that);
endp; 

proc(4)=sbmest(y,x,th);
local k, tim, du, xb, xa, yb, ya, xxb, xxa, bb, ba, eb, ea; 

k=cols(x);
tim=seqa(1,1, rows(y));
du=(tim.<=th);
xb=selif(x, du); xa=selif(x, (1-du));
yb=selif(y, du); ya=selif(y, (1-du));
xxb=invpd(xb'xb); xxa=invpd(xa'xa); 
bb=xxb*(xb'yb); ba=xxa*(xa'ya);
eb=yb-xb*bb; ea=ya-xa*ba;
retp (bb, ba, eb, ea); 
endp;

proc(3)=sbtvarc(y, x, q); 
local t, r, r1, r2,step, tt, st, gat, ddt, qt1, qt2, qt, s, xi1, xi2, yi1, yi2, qi1, qi2;
local q1x, q2x,q1n, q2n,nq, qq1, qq2, qd1, qd2,qqd, du1, xi1l,yi1l, xi1h, yi1h, ui1h, ui1l, sig1l, sig1h; 
local du2, xi2l,yi2l, xi2h, yi2h, ui2h, ui2l, sig2l, sig2h, tf, gh, dh;

t=rows(y);
r1=ceil(pr2*t); 
r2=floor((1-pr2)*t);
step=(r2-r1)/gr;
r=seqa(r1, round(step), gr);
tt=rows(r); 
st=zeros(tt,1); 
ddt=zeros(tt,1); 
gat=zeros(tt,1);
for i(1,tt, 1); 
xi1=x[1:r[i],.]; yi1=y[1:r[i],.]; qi1=q[1:r[i],.]; 
xi2=x[r[i]+1:t,.]; yi2=y[r[i]+1:t,.]; qi2=q[r[i]+1:t,.]; 
qt1=sortc(qi1[.,1],1);
qt1=qt1[(floor(prt*rows(qt1)))+1:ceil((1-prt)*rows(qt1))];
qt2=sortc(qi2[.,1],1);
qt2=qt2[(floor(prt*rows(qt2)))+1:ceil((1-prt)*rows(qt2))];
q1x=maxc(qt1); q1n=minc(qt1);
q2x=maxc(qt2); q2n=minc(qt2);
qq1=minc(q1x|q2x); qq2=maxc(q1n|q2n);
qt=seqa(qq2, (qq1-qq2)/75, 75);
nq=rows(qt); 
s=zeros(nq,cols(q)); 
for j (1, cols(q), 1); 
qd1=qi1[.,j];
qd2=qi2[.,j]; 
for hh (1, nq, 1); 
qqd=qt[hh];
du1=(qd1.<=qqd);
xi1l=selif(xi1,du1); yi1l=selif(yi1,du1); 
xi1h=delif(xi1,du1); yi1h=delif(yi1,du1);
ui1l=yi1l-xi1l*(ginv(xi1l'xi1l)*(xi1l'yi1l));
ui1h=yi1h-xi1h*(ginv(xi1h'xi1h)*(xi1h'yi1h)); 
sig1l=(ui1l'ui1l)./rows(ui1l); sig1h=(ui1h'ui1h)./rows(ui1h);
du2=(qd2.<=qqd);
xi2l=selif(xi2,du2); yi2l=selif(yi2,du2); 
xi2h=delif(xi2,du2); yi2h=delif(yi2,du2);
ui2l=yi2l-xi2l*(ginv(xi2l'xi2l)*(xi2l'yi2l));
ui2h=yi2h-xi2h*(ginv(xi2h'xi2h)*(xi2h'yi2h)); 
sig2l=(ui2l'ui2l)./rows(ui2l); sig2h=(ui2h'ui2h)./rows(ui2h);
s[hh,j]=rows(ui1l)*ln(det(sig1l))+rows(ui1h)*ln(det(sig1h))
      +rows(ui2l)*ln(det(sig2l))+rows(ui2h)*ln(det(sig2h)); 
endfor; 
endfor; 
ddt[i] =minindc(minc(s));  
st[i]=minc(s[.,ddt[i]]);
gat[i]=qt[minindc(s[.,ddt[i]])];
endfor;
tf=r[minindc(st)]; 
dh=ddt[minindc(st)];
gh=gat[minindc(st)];

retp(tf, dh, gh); 
endp; 

proc ginv(m);
local mi;
trap 1;
mi=invpd(m);
if scalerr(mi);
mi=pinv(m);
endif;
if scalerr(mi);
trap 0;
mi=invswp(m);
endif;
retp(mi);
endp;

proc(5) = tvtvar (y, x, q); 
local t, r1, r2, step, r, rr, ss, resu, xi1, yi1, qi1,qq1, qqr1, qqn1, s1;
local qqd, du, xi1l, yi1l, xi1h, yi1h, xi2l, yi2l, xi2h, yi2h,xi2, yi2,
qi2,qq2, qqr2, qqn2, s2, ui1l, ui2l, ui1h, ui2h, ti1, ti2;   
local sigl, sigh, st, taf, ghat1, ghat2, dhat1, dhat2, qd1, qd2; 

t=rows(y); 
r1=ceil(pr2*t); 
r2=floor((1-pr2)*t);
step=(r2-r1)/gr;
r=seqa(r1, round(step), gr);
rr=rows(r);
ss=zeros(rr,2); 
resu=zeros(rr,4);

/*search over time */ 
for i (1, rr,1);
/*the lower part */
xi1=x[1:r[i],.]; yi1=y[1:r[i],.]; qi1=q[1:r[i],.]; 
ti1=rows(yi1);
qq1=sortc(qi1[.,1],1);
qqr1=trimr(qq1, ceil(prt*ti1), ceil ((prt)*ti1));
qqn1=rows(qqr1);
s1=zeros(qqn1, dmax);
for k (1,dmax,1);
qd1=qi1[.,k]; 
for j (1, qqn1, 1);
qqd=qqr1[j];
du=(qd1.<=qqd);  
xi1l=selif(xi1,du); yi1l=selif(yi1,du); 
xi1h=delif(xi1,du); yi1h=delif(yi1,du);
ui1l=yi1l-xi1l*(invpd(xi1l'xi1l)*(xi1l'yi1l));
ui1h=yi1h-xi1h*(invpd(xi1h'xi1h)*(xi1h'yi1h)); 
sigl=(ui1l'ui1l)./rows(ui1l); sigh=(ui1h'ui1h)./rows(ui1h);
s1[j,k]=-rows(ui1l)*ln(det(sigl))-rows(ui1h)*ln(det(sigh));
endfor;
endfor;
resu[i,1] =maxindc(maxc(s1)); /*dhat1*/
ss[i,1]=maxc(s1[.,resu[i,1]]);
resu[i,2]=qqr1[maxindc(s1[.,resu[i,1]])]; /*ghat1*/

/*the upper part */
xi2=x[r[i]+1:t,.]; yi2=y[r[i]+1:t,.]; qi2=q[r[i]+1:t,.]; 
ti2=rows(yi2);
qq2=sortc(qi2[.,1],1);
qqr2=trimr(qq2, ceil(prt*ti2), ceil ((prt)*ti2));
qqn2=rows(qqr2);
s2=zeros(qqn2, dmax);
for l (1, dmax, 1); 
qd2=qi2[.,l];
for h (1, qqn2,1);
qqd=qqr2[h];
du=(qd2.<=qqd);  
xi2l=selif(xi2,du); yi2l=selif(yi2,du); 
xi2h=delif(xi2,du); yi2h=delif(yi2,du);
ui2l=yi2l-xi2l*(invpd(xi2l'xi2l)*(xi2l'yi2l));
ui2h=yi2h-xi2h*(invpd(xi2h'xi2h)*(xi2h'yi2h)); 
sigl=(ui2l'ui2l)./rows(ui2l); sigh=(ui2h'ui2h)./rows(ui2h);
s2[h,l]=-rows(ui2l)*ln(det(sigl))-rows(ui2h)*ln(det(sigh));
endfor; endfor; 
resu[i,3]=maxindc(maxc(s2)); /*dhat2*/  
ss[i,2]=maxc(s2[.,resu[i,3]]);
resu[i,4]=qqr2[maxindc(s2[.,resu[i,3]])]; /*ghat2*/
endfor; 
st= ss[.,1]+ss[.,2];
taf=r[maxindc(st)];
 
ghat1=resu[maxindc(st),2];
ghat2=resu[maxindc(st),4];
dhat1=resu[maxindc(st),1];
dhat2=resu[maxindc(st),3];

retp(taf, ghat1, ghat2, dhat1, dhat2); 
endp;
